import { Directive, ViewContainerRef, Injectable, Component, Inject, ReflectiveInjector, Input, NgZone, ComponentFactoryResolver, ViewChild, NgModule, ApplicationRef } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA, MatDialog, MatButtonModule, MatCheckboxModule, MatDialogModule, MatFormFieldModule, MatIconModule, MatInputModule, MatMenuModule, MatOptionModule, MatProgressBarModule, MatProgressSpinnerModule, MatSelectModule, MatTooltipModule } from '@angular/material';
import { FormControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { __values, __extends } from 'tslib';
import * as Resumable from 'resumablejs';
import { createHash } from 'crypto-browserify';
import { saveAs } from 'file-saver';
import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { FlexLayoutModule } from '@angular/flex-layout';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/enums/custom-event-type.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var CustomEventType = {
    UNKNOWN: 0,
    // This event can be used to bootstrap the app module. An IAppConfig can be passed as detail payload.
    CREATE: 1,
    // This event can be used to trigger an item download. The filename, url and size can be passed as detail payload.
    DOWNLOAD_ITEM: 2,
    // This event can be used to update the app configuration. An IAppConfig can be passed as detail payload.
    UPDATE_CONFIG: 3,
    // Indicates that the app has been initialized.
    INIT: 4,
    // Indicates that the overall upload has been completed.
    UPLOAD_COMPLETED: 5,
    // Indicates that the overall download has been completed.
    DOWNLOAD_COMPLETED: 6,
    // Indicates that an item has been added. It will be passed a IDatatransferItem as detail payload.
    ITEM_ADDED: 7,
    // Indicates that an item has been removed. It will be passed a IDatatransferItem as detail payload.
    ITEM_REMOVED: 8,
    // Indicates that an item has been completed.
    ITEM_COMPLETED: 9,
    // Indicates that all items have been cleared.
    ITEMS_CLEARED: 10,
};
CustomEventType[CustomEventType.UNKNOWN] = 'UNKNOWN';
CustomEventType[CustomEventType.CREATE] = 'CREATE';
CustomEventType[CustomEventType.DOWNLOAD_ITEM] = 'DOWNLOAD_ITEM';
CustomEventType[CustomEventType.UPDATE_CONFIG] = 'UPDATE_CONFIG';
CustomEventType[CustomEventType.INIT] = 'INIT';
CustomEventType[CustomEventType.UPLOAD_COMPLETED] = 'UPLOAD_COMPLETED';
CustomEventType[CustomEventType.DOWNLOAD_COMPLETED] = 'DOWNLOAD_COMPLETED';
CustomEventType[CustomEventType.ITEM_ADDED] = 'ITEM_ADDED';
CustomEventType[CustomEventType.ITEM_REMOVED] = 'ITEM_REMOVED';
CustomEventType[CustomEventType.ITEM_COMPLETED] = 'ITEM_COMPLETED';
CustomEventType[CustomEventType.ITEMS_CLEARED] = 'ITEMS_CLEARED';
// tslint:disable-next-line: no-namespace
var CustomEventTypeExtensions;
(function (CustomEventTypeExtensions) {
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_NS = 'github:niklr/angular-material-datatransfer.';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_UNKNOWN = CUSTOM_EVENT_TYPE_NS + 'unknown';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_CREATE = CUSTOM_EVENT_TYPE_NS + 'create';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_DOWNLOAD_ITEM = CUSTOM_EVENT_TYPE_NS + 'download-item';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_UPDATE_CONFIG = CUSTOM_EVENT_TYPE_NS + 'update-config';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_INIT = CUSTOM_EVENT_TYPE_NS + 'init';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_UPLOAD_COMPLETED = CUSTOM_EVENT_TYPE_NS + 'upload-completed';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_DOWNLOAD_COMPLETED = CUSTOM_EVENT_TYPE_NS + 'download-completed';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_ITEM_ADDED = CUSTOM_EVENT_TYPE_NS + 'item-added';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_ITEM_REMOVED = CUSTOM_EVENT_TYPE_NS + 'item-removed';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_ITEM_COMPLETED = CUSTOM_EVENT_TYPE_NS + 'item-completed';
    /** @type {?} */
    var CUSTOM_EVENT_TYPE_ITEMS_CLEARED = CUSTOM_EVENT_TYPE_NS + 'items-cleared';
    /**
     * @param {?} type
     * @return {?}
     */
    function toString(type) {
        switch (type) {
            case CustomEventType.CREATE:
                return CUSTOM_EVENT_TYPE_CREATE;
            case CustomEventType.DOWNLOAD_ITEM:
                return CUSTOM_EVENT_TYPE_DOWNLOAD_ITEM;
            case CustomEventType.UPDATE_CONFIG:
                return CUSTOM_EVENT_TYPE_UPDATE_CONFIG;
            case CustomEventType.INIT:
                return CUSTOM_EVENT_TYPE_INIT;
            case CustomEventType.UPLOAD_COMPLETED:
                return CUSTOM_EVENT_TYPE_UPLOAD_COMPLETED;
            case CustomEventType.DOWNLOAD_COMPLETED:
                return CUSTOM_EVENT_TYPE_DOWNLOAD_COMPLETED;
            case CustomEventType.ITEM_ADDED:
                return CUSTOM_EVENT_TYPE_ITEM_ADDED;
            case CustomEventType.ITEM_REMOVED:
                return CUSTOM_EVENT_TYPE_ITEM_REMOVED;
            case CustomEventType.ITEM_COMPLETED:
                return CUSTOM_EVENT_TYPE_ITEM_COMPLETED;
            case CustomEventType.ITEMS_CLEARED:
                return CUSTOM_EVENT_TYPE_ITEMS_CLEARED;
            default:
                return CUSTOM_EVENT_TYPE_UNKNOWN;
        }
    }
    CustomEventTypeExtensions.toString = toString;
    /**
     * @param {?} type
     * @return {?}
     */
    function toEnum(type) {
        switch (type) {
            case CUSTOM_EVENT_TYPE_CREATE:
                return CustomEventType.CREATE;
            case CUSTOM_EVENT_TYPE_DOWNLOAD_ITEM:
                return CustomEventType.DOWNLOAD_ITEM;
            case CUSTOM_EVENT_TYPE_UPDATE_CONFIG:
                return CustomEventType.UPDATE_CONFIG;
            case CUSTOM_EVENT_TYPE_INIT:
                return CustomEventType.INIT;
            case CUSTOM_EVENT_TYPE_UPLOAD_COMPLETED:
                return CustomEventType.UPLOAD_COMPLETED;
            case CUSTOM_EVENT_TYPE_DOWNLOAD_COMPLETED:
                return CustomEventType.DOWNLOAD_COMPLETED;
            case CUSTOM_EVENT_TYPE_ITEM_ADDED:
                return CustomEventType.ITEM_ADDED;
            case CUSTOM_EVENT_TYPE_ITEM_REMOVED:
                return CustomEventType.ITEM_REMOVED;
            case CUSTOM_EVENT_TYPE_ITEM_COMPLETED:
                return CustomEventType.ITEM_COMPLETED;
            case CUSTOM_EVENT_TYPE_ITEMS_CLEARED:
                return CustomEventType.ITEMS_CLEARED;
            default:
                return CustomEventType.UNKNOWN;
        }
    }
    CustomEventTypeExtensions.toEnum = toEnum;
})(CustomEventTypeExtensions || (CustomEventTypeExtensions = {}));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/directives/host.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var HostDirective = /** @class */ (function () {
    function HostDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    HostDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[amd-host]',
                },] }
    ];
    /** @nocollapse */
    HostDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    return HostDirective;
}());
if (false) {
    /** @type {?} */
    HostDirective.prototype.viewContainerRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/app-config.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CoreAppConfig = /** @class */ (function () {
    function CoreAppConfig() {
        this.showUploadDropzone = true;
        this.uploadBrowseElementId = undefined;
        this.uploadDropElementId = undefined;
        this.paginationRppOptions = [5, 10, 25];
        this.simultaneousDownloads = 2;
        this.downloadMethod = 'GET';
        this.downloadHeaders = {};
        this.downloadWithCredentials = false;
        this.downloadXhrTimeout = 0;
        this.preprocessHashEnabled = false;
        this.preprocessHashChecked = true;
        this.preprocessHashTarget = 'https://httpbin.org';
        this.preprocessHashMethod = 'GET';
        this.preprocessHashParameterName = 'hash';
        this.preprocessHashFileNameParameterName = 'filename';
        this.preprocessHashFunctionName = 'sha1';
        this.preprocessHashEncodingName = 'hex';
        this.preprocessHashInputEncodingName = 'latin1';
        this.preprocessHashTooltipContent = 'The preprocess option checks if the file is already on the system before uploading.';
        this.parseMessageCallback = (/**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            return message;
        });
        this.getTarget = (/**
         * @param {?} request
         * @param {?} params
         * @return {?}
         */
        function (request, params) {
            /** @type {?} */
            var target;
            if (request === 'preprocessHash' && this.preprocessHashChecked) {
                target = this.preprocessHashTarget;
            }
            if (typeof target === 'function') {
                return target(params);
            }
            if (target) {
                /** @type {?} */
                var separator = target.indexOf('?') < 0 ? '?' : '&';
                /** @type {?} */
                var joinedParams = params.join('&');
                return target + separator + joinedParams;
            }
            else {
                return;
            }
        });
    }
    return CoreAppConfig;
}());
if (false) {
    /** @type {?} */
    CoreAppConfig.prototype.showUploadDropzone;
    /** @type {?} */
    CoreAppConfig.prototype.uploadBrowseElementId;
    /** @type {?} */
    CoreAppConfig.prototype.uploadDropElementId;
    /** @type {?} */
    CoreAppConfig.prototype.paginationRppOptions;
    /** @type {?} */
    CoreAppConfig.prototype.simultaneousDownloads;
    /** @type {?} */
    CoreAppConfig.prototype.downloadMethod;
    /** @type {?} */
    CoreAppConfig.prototype.downloadHeaders;
    /** @type {?} */
    CoreAppConfig.prototype.downloadWithCredentials;
    /** @type {?} */
    CoreAppConfig.prototype.downloadXhrTimeout;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashEnabled;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashChecked;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashTarget;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashMethod;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashParameterName;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashFileNameParameterName;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashFunctionName;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashEncodingName;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashInputEncodingName;
    /** @type {?} */
    CoreAppConfig.prototype.preprocessHashTooltipContent;
    /** @type {?} */
    CoreAppConfig.prototype.parseMessageCallback;
    /** @type {?} */
    CoreAppConfig.prototype.getTarget;
}
var ResumableJsAppConfig = /** @class */ (function () {
    function ResumableJsAppConfig() {
        this.chunkSize = 1 * 1024 * 1024;
        this.forceChunkSize = false;
        this.simultaneousUploads = 3;
        this.fileParameterName = 'file';
        this.chunkNumberParameterName = 'resumableChunkNumber';
        this.chunkSizeParameterName = 'resumableChunkSize';
        this.currentChunkSizeParameterName = 'resumableCurrentChunkSize';
        this.totalSizeParameterName = 'resumableTotalSize';
        this.typeParameterName = 'resumableType';
        this.identifierParameterName = 'resumableIdentifier';
        this.fileNameParameterName = 'resumableFilename';
        this.relativePathParameterName = 'resumableRelativePath';
        this.totalChunksParameterName = 'resumableTotalChunks';
        this.throttleProgressCallbacks = 0.5;
        this.query = {};
        this.headers = {};
        this.preprocess = null;
        this.preprocessFile = null;
        this.method = 'multipart';
        this.uploadMethod = 'POST';
        this.testMethod = 'GET';
        this.target = 'https://httpbin.org';
        this.testTarget = null;
        this.parameterNamespace = '';
        this.testChunks = true;
        this.generateUniqueIdentifier = null;
        this.getTarget = null;
        this.maxChunkRetries = 100;
        this.chunkRetryInterval = undefined;
        this.permanentErrors = [400, 404, 405, 415, 501];
        this.maxFiles = undefined;
        this.withCredentials = false;
        this.xhrTimeout = 0;
        this.clearInput = true;
        this.chunkFormat = 'blob';
        this.minFileSize = 1;
        this.maxFileSize = undefined;
        this.fileType = [];
        this.maxFilesErrorCallback = (/**
         * @param {?} files
         * @param {?} errorCount
         * @return {?}
         */
        function (files, errorCount) {
            alert('Please upload no more than ' + this.maxFiles + ' file' + (this.maxFiles === 1 ? '' : 's') + ' at a time.');
        });
        this.minFileSizeErrorCallback = (/**
         * @param {?} file
         * @param {?} errorCount
         * @return {?}
         */
        function (file, errorCount) {
            alert(file.fileName || file.name + ' is too small; please upload files larger than ' + this.minFileSize + '.');
        });
        this.maxFileSizeErrorCallback = (/**
         * @param {?} file
         * @param {?} errorCount
         * @return {?}
         */
        function (file, errorCount) {
            alert(file.fileName || file.name + ' is too large; please upload files less than ' + this.maxFileSize + '.');
        });
        this.fileTypeErrorCallback = (/**
         * @param {?} file
         * @param {?} errorCount
         * @return {?}
         */
        function (file, errorCount) {
            alert(file.fileName || file.name + ' has type not allowed; please upload files of type ' + this.fileType + '.');
        });
    }
    return ResumableJsAppConfig;
}());
if (false) {
    /** @type {?} */
    ResumableJsAppConfig.prototype.chunkSize;
    /** @type {?} */
    ResumableJsAppConfig.prototype.forceChunkSize;
    /** @type {?} */
    ResumableJsAppConfig.prototype.simultaneousUploads;
    /** @type {?} */
    ResumableJsAppConfig.prototype.fileParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.chunkNumberParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.chunkSizeParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.currentChunkSizeParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.totalSizeParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.typeParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.identifierParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.fileNameParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.relativePathParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.totalChunksParameterName;
    /** @type {?} */
    ResumableJsAppConfig.prototype.throttleProgressCallbacks;
    /** @type {?} */
    ResumableJsAppConfig.prototype.query;
    /** @type {?} */
    ResumableJsAppConfig.prototype.headers;
    /** @type {?} */
    ResumableJsAppConfig.prototype.preprocess;
    /** @type {?} */
    ResumableJsAppConfig.prototype.preprocessFile;
    /** @type {?} */
    ResumableJsAppConfig.prototype.method;
    /** @type {?} */
    ResumableJsAppConfig.prototype.uploadMethod;
    /** @type {?} */
    ResumableJsAppConfig.prototype.testMethod;
    /** @type {?} */
    ResumableJsAppConfig.prototype.prioritizeFirstAndLastChunk;
    /** @type {?} */
    ResumableJsAppConfig.prototype.target;
    /** @type {?} */
    ResumableJsAppConfig.prototype.testTarget;
    /** @type {?} */
    ResumableJsAppConfig.prototype.parameterNamespace;
    /** @type {?} */
    ResumableJsAppConfig.prototype.testChunks;
    /** @type {?} */
    ResumableJsAppConfig.prototype.generateUniqueIdentifier;
    /** @type {?} */
    ResumableJsAppConfig.prototype.getTarget;
    /** @type {?} */
    ResumableJsAppConfig.prototype.maxChunkRetries;
    /** @type {?} */
    ResumableJsAppConfig.prototype.chunkRetryInterval;
    /** @type {?} */
    ResumableJsAppConfig.prototype.permanentErrors;
    /** @type {?} */
    ResumableJsAppConfig.prototype.maxFiles;
    /** @type {?} */
    ResumableJsAppConfig.prototype.withCredentials;
    /** @type {?} */
    ResumableJsAppConfig.prototype.xhrTimeout;
    /** @type {?} */
    ResumableJsAppConfig.prototype.clearInput;
    /** @type {?} */
    ResumableJsAppConfig.prototype.chunkFormat;
    /** @type {?} */
    ResumableJsAppConfig.prototype.minFileSize;
    /** @type {?} */
    ResumableJsAppConfig.prototype.maxFileSize;
    /** @type {?} */
    ResumableJsAppConfig.prototype.fileType;
    /** @type {?} */
    ResumableJsAppConfig.prototype.maxFilesErrorCallback;
    /** @type {?} */
    ResumableJsAppConfig.prototype.minFileSizeErrorCallback;
    /** @type {?} */
    ResumableJsAppConfig.prototype.maxFileSizeErrorCallback;
    /** @type {?} */
    ResumableJsAppConfig.prototype.fileTypeErrorCallback;
}
/**
 * @record
 */
function IAppConfig() { }
if (false) {
    /** @type {?} */
    IAppConfig.prototype.production;
    /** @type {?} */
    IAppConfig.prototype.core;
    /** @type {?} */
    IAppConfig.prototype.resumablejs;
}
var AppConfig = /** @class */ (function () {
    function AppConfig() {
        this.production = true;
        this.core = new CoreAppConfig();
        this.resumablejs = new ResumableJsAppConfig();
    }
    return AppConfig;
}());
if (false) {
    /** @type {?} */
    AppConfig.prototype.production;
    /** @type {?} */
    AppConfig.prototype.core;
    /** @type {?} */
    AppConfig.prototype.resumablejs;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/config.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ConfigService = /** @class */ (function () {
    function ConfigService() {
    }
    /**
     * @param {?} config
     * @return {?}
     */
    ConfigService.prototype.load = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        if (!!config) {
            ConfigService.settings.production = config.production;
            if (!!config.core) {
                Object.keys(config.core).forEach((/**
                 * @param {?} propertyName
                 * @return {?}
                 */
                function (propertyName) {
                    if (typeof config.core[propertyName] !== 'undefined') {
                        ConfigService.settings.core[propertyName] = config.core[propertyName];
                    }
                }));
            }
            if (!!config.resumablejs) {
                Object.keys(config.resumablejs).forEach((/**
                 * @param {?} propertyName
                 * @return {?}
                 */
                function (propertyName) {
                    if (typeof config.resumablejs[propertyName] !== 'undefined') {
                        ConfigService.settings.resumablejs[propertyName] = config.resumablejs[propertyName];
                    }
                }));
            }
        }
    };
    ConfigService.settings = new AppConfig();
    ConfigService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ConfigService.ctorParameters = function () { return []; };
    return ConfigService;
}());
if (false) {
    /** @type {?} */
    ConfigService.settings;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/enums/transfer-status.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var TransferStatus = {
    Ready: 0,
    Queued: 1,
    Preprocessing: 2,
    Uploading: 3,
    Downloading: 4,
    Finished: 5,
    Failed: 6,
};
TransferStatus[TransferStatus.Ready] = 'Ready';
TransferStatus[TransferStatus.Queued] = 'Queued';
TransferStatus[TransferStatus.Preprocessing] = 'Preprocessing';
TransferStatus[TransferStatus.Uploading] = 'Uploading';
TransferStatus[TransferStatus.Downloading] = 'Downloading';
TransferStatus[TransferStatus.Finished] = 'Finished';
TransferStatus[TransferStatus.Failed] = 'Failed';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/enums/transfer-type.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var TransferType = {
    Upload: 0,
    Download: 1,
};
TransferType[TransferType.Upload] = 'Upload';
TransferType[TransferType.Download] = 'Download';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/browse-dialog.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BrowseDialogComponent = /** @class */ (function () {
    function BrowseDialogComponent(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.datatransferFacade = (/** @type {?} */ (this.data.datatransferFacade));
    }
    /**
     * @return {?}
     */
    BrowseDialogComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.datatransferFacade.assignUploadBrowse(document.getElementById('amd-browse-files'));
        this.datatransferFacade.assignUploadBrowse(document.getElementById('amd-browse-folder'), true);
    };
    /**
     * @return {?}
     */
    BrowseDialogComponent.prototype.close = /**
     * @return {?}
     */
    function () {
        this.dialogRef.close();
    };
    /**
     * @return {?}
     */
    BrowseDialogComponent.prototype.onNoClick = /**
     * @return {?}
     */
    function () {
        this.close();
    };
    BrowseDialogComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'amd-browse-dialog',
                    template: "<mat-dialog-content>Select specific files or a folder</mat-dialog-content>\r\n<mat-dialog-actions>\r\n    <button mat-raised-button id=\"amd-browse-files\" (click)=\"close()\" tabindex=\"1\">\r\n        <mat-icon>insert_drive_file</mat-icon> Files</button>\r\n    <button mat-raised-button id=\"amd-browse-folder\" (click)=\"close()\" tabindex=\"2\">\r\n        <mat-icon>folder_open</mat-icon> Folder</button>\r\n</mat-dialog-actions>"
                }] }
    ];
    /** @nocollapse */
    BrowseDialogComponent.ctorParameters = function () { return [
        { type: MatDialogRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
    ]; };
    return BrowseDialogComponent;
}());
if (false) {
    /** @type {?} */
    BrowseDialogComponent.prototype.datatransferFacade;
    /** @type {?} */
    BrowseDialogComponent.prototype.dialogRef;
    /** @type {?} */
    BrowseDialogComponent.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/edit-dialog.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EditDialogComponent = /** @class */ (function () {
    function EditDialogComponent(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.datatransferFacade = (/** @type {?} */ (this.data.datatransferFacade));
        this.mode = this.data.mode;
        this.item = (/** @type {?} */ (this.data.item));
        this.itemPath = this.item.path;
        this.itemName = this.item.name;
        this.editFormControl = new FormControl('', []);
    }
    /**
     * @return {?}
     */
    EditDialogComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    EditDialogComponent.prototype.close = /**
     * @return {?}
     */
    function () {
        this.dialogRef.close();
    };
    /**
     * @return {?}
     */
    EditDialogComponent.prototype.onNoClick = /**
     * @return {?}
     */
    function () {
        this.close();
    };
    /**
     * @return {?}
     */
    EditDialogComponent.prototype.editPath = /**
     * @return {?}
     */
    function () {
        try {
            this.datatransferFacade.editPath(this.item, this.item.path, this.itemPath);
            this.close();
        }
        catch (error) {
            this.errorMessage = error;
        }
    };
    /**
     * @return {?}
     */
    EditDialogComponent.prototype.editFilename = /**
     * @return {?}
     */
    function () {
        try {
            this.datatransferFacade.editFilename(this.item, this.itemName);
            this.close();
        }
        catch (error) {
            this.errorMessage = error;
        }
    };
    EditDialogComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'amd-edit-dialog',
                    template: "<div *ngIf=\"mode === 'edit-path'\">\r\n    <mat-dialog-content>\r\n        <p>Enter a new path:</p>\r\n        <form>\r\n            <mat-form-field>\r\n                <input matInput autocomplete=\"off\" tabindex=\"1\" [value]=\"itemPath\"\r\n                    (input)=\"itemPath = $event.target.value; errorMessage = undefined;\" [formControl]=\"editFormControl\">\r\n            </mat-form-field>\r\n            <mat-error *ngIf=\"errorMessage\">\r\n                {{errorMessage}}\r\n            </mat-error>\r\n        </form>\r\n    </mat-dialog-content>\r\n    <mat-dialog-actions>\r\n        <button mat-raised-button (click)=\"editPath()\" tabindex=\"2\">Ok</button>\r\n        <button mat-raised-button (click)=\"close()\" tabindex=\"-1\">Cancel</button>\r\n    </mat-dialog-actions>\r\n</div>\r\n<div *ngIf=\"mode === 'edit-filename'\">\r\n    <mat-dialog-content>\r\n        <p>Enter a new filename:</p>\r\n        <form>\r\n            <mat-form-field>\r\n                <input matInput autocomplete=\"off\" tabindex=\"1\" [value]=\"itemName\"\r\n                    (input)=\"itemName = $event.target.value; errorMessage = undefined;\" [formControl]=\"editFormControl\">\r\n            </mat-form-field>\r\n            <mat-error *ngIf=\"errorMessage\">\r\n                {{errorMessage}}\r\n            </mat-error>\r\n        </form>\r\n    </mat-dialog-content>\r\n    <mat-dialog-actions>\r\n        <button mat-raised-button (click)=\"editFilename()\" tabindex=\"2\">Ok</button>\r\n        <button mat-raised-button (click)=\"close()\" tabindex=\"-1\">Cancel</button>\r\n    </mat-dialog-actions>\r\n</div>"
                }] }
    ];
    /** @nocollapse */
    EditDialogComponent.ctorParameters = function () { return [
        { type: MatDialogRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
    ]; };
    return EditDialogComponent;
}());
if (false) {
    /** @type {?} */
    EditDialogComponent.prototype.datatransferFacade;
    /** @type {?} */
    EditDialogComponent.prototype.mode;
    /** @type {?} */
    EditDialogComponent.prototype.item;
    /** @type {?} */
    EditDialogComponent.prototype.itemPath;
    /** @type {?} */
    EditDialogComponent.prototype.itemName;
    /** @type {?} */
    EditDialogComponent.prototype.errorMessage;
    /** @type {?} */
    EditDialogComponent.prototype.editFormControl;
    /** @type {?} */
    EditDialogComponent.prototype.dialogRef;
    /** @type {?} */
    EditDialogComponent.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/facades/datatransfer.facade.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DatatransferFacade = /** @class */ (function () {
    function DatatransferFacade(logger, zone, store, dateUtil, paginationService, exportService, uploader, downloader, dialog) {
        this.logger = logger;
        this.zone = zone;
        this.store = store;
        this.dateUtil = dateUtil;
        this.paginationService = paginationService;
        this.exportService = exportService;
        this.uploader = uploader;
        this.downloader = downloader;
        this.dialog = dialog;
        // Interval in milliseconds to calculate progress:
        this.progressInterval = 200;
        // Interval in milliseconds to calculate bitrate:
        this.bitrateInterval = 1000;
        this.uploadProgress = this.store.uploadProgress;
        this.downloadProgress = this.store.downloadProgress;
        this.init(this.uploader, this.uploadProgress);
        this.init(this.downloader, this.downloadProgress);
    }
    /**
     * @private
     * @param {?} datatransfer
     * @param {?} progressContainer
     * @return {?}
     */
    DatatransferFacade.prototype.init = /**
     * @private
     * @param {?} datatransfer
     * @param {?} progressContainer
     * @return {?}
     */
    function (datatransfer, progressContainer) {
        datatransfer.on('itemAdded', (/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            that.zone.run((/**
             * @return {?}
             */
            function () {
                that.addItem(item);
            }));
        }).bind(this));
        datatransfer.on('zoneUpdated', (/**
         * @param {?} item
         * @param {?} status
         * @param {?=} message
         * @return {?}
         */
        function (item, status, message) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            that.zone.run((/**
             * @return {?}
             */
            function () {
                // console.log(that.uploader.isWorking());
            }));
        }).bind(this));
        datatransfer.on('itemStatusChanged', (/**
         * @param {?} item
         * @param {?} status
         * @param {?=} message
         * @return {?}
         */
        function (item, status, message) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            that.zone.run((/**
             * @return {?}
             */
            function () {
                that.changeItemStatus(item, status, message);
            }));
        }).bind(this));
        datatransfer.on('itemProgressUpdated', (/**
         * @param {?} item
         * @param {?} progress
         * @return {?}
         */
        function (item, progress) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            that.zone.run((/**
             * @return {?}
             */
            function () {
                that.updateItemProgress(item, progress);
            }));
        }).bind(this));
        datatransfer.on('overallProgressUpdated', (/**
         * @param {?} transferType
         * @param {?} progress
         * @return {?}
         */
        function (transferType, progress) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            that.zone.run((/**
             * @return {?}
             */
            function () {
                that.updateOverallProgress(progressContainer, transferType, progress);
            }));
        }).bind(this));
        datatransfer.on('overallSizeUpdated', (/**
         * @param {?} size
         * @return {?}
         */
        function (size) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            that.zone.run((/**
             * @return {?}
             */
            function () {
                that.updateOverallSize(progressContainer, size);
            }));
        }).bind(this));
    };
    /**
     * @param {?} element
     * @param {?=} isDirectory
     * @return {?}
     */
    DatatransferFacade.prototype.assignUploadBrowse = /**
     * @param {?} element
     * @param {?=} isDirectory
     * @return {?}
     */
    function (element, isDirectory) {
        if (isDirectory === void 0) { isDirectory = false; }
        this.uploader.assignBrowse(element, isDirectory);
    };
    /**
     * @param {?} element
     * @return {?}
     */
    DatatransferFacade.prototype.assignUploadDrop = /**
     * @param {?} element
     * @return {?}
     */
    function (element) {
        this.uploader.assignDrop(element);
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.openBrowseDialog = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var dialogRef = this.dialog.open(BrowseDialogComponent, {
            data: {
                datatransferFacade: this
            }
        });
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.openEditPathDialog = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        /** @type {?} */
        var dialogRef = this.dialog.open(EditDialogComponent, {
            data: {
                datatransferFacade: this,
                mode: 'edit-path',
                item: item
            }
        });
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.openEditFilenameDialog = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        /** @type {?} */
        var dialogRef = this.dialog.open(EditDialogComponent, {
            data: {
                datatransferFacade: this,
                mode: 'edit-filename',
                item: item
            }
        });
    };
    /**
     * @param {?} checked
     * @return {?}
     */
    DatatransferFacade.prototype.toggleVisible = /**
     * @param {?} checked
     * @return {?}
     */
    function (checked) {
        this.paginationService.paginatedItems.forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            item.isSelected = checked;
        }));
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.startAll = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.store.getItems().forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            /** @type {?} */
            var that = (/** @type {?} */ (_this));
            if (item.transferType === TransferType.Upload && item.status === TransferStatus.Ready) {
                that.changeItemStatus(item, TransferStatus.Queued);
            }
        }));
        this.uploader.startAll();
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.pauseAll = /**
     * @return {?}
     */
    function () {
        this.store.getItems().forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            item.preprocessContainer.pause(true);
        }));
        this.uploader.pauseAll();
        this.downloader.pauseAll();
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.removeAll = /**
     * @return {?}
     */
    function () {
        this.store.getItems().forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            item.preprocessContainer.cancel(true);
        }));
        this.uploader.removeAll();
        this.downloader.removeAll();
        this.store.clear();
        this.uploadProgress.reset(0);
        this.paginationService.update(0);
        document.dispatchEvent(new CustomEvent(CustomEventTypeExtensions.toString(CustomEventType.ITEMS_CLEARED)));
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.retryAll = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.store.getByStatus(TransferStatus.Failed).forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            /** @type {?} */
            var that = (/** @type {?} */ (_this));
            that.retryItem(item);
        }));
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.removeSelected = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var temp = this.store.getSelected().slice();
        temp.forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            /** @type {?} */
            var that = (/** @type {?} */ (_this));
            that.removeItem(item);
        }));
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.addItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (!!item) {
            this.store.addItem(item);
            this.paginationService.update(this.store.count);
            document.dispatchEvent(new CustomEvent(CustomEventTypeExtensions.toString(CustomEventType.ITEM_ADDED), { detail: item }));
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.removeItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (!!item) {
            item.preprocessContainer.cancel(true);
            switch (item.transferType) {
                case TransferType.Upload:
                    this.uploader.removeItem(item);
                    break;
                case TransferType.Download:
                    this.downloader.removeItem(item);
                    break;
                default:
                    break;
            }
            this.store.removeById(item.id);
            this.paginationService.update(this.store.count);
            document.dispatchEvent(new CustomEvent(CustomEventTypeExtensions.toString(CustomEventType.ITEM_REMOVED), { detail: item }));
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.retryItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (!!item) {
            item.preprocessContainer.cancel(true);
            switch (item.transferType) {
                case TransferType.Upload:
                    this.uploader.retryItem(item);
                    break;
                case TransferType.Download:
                    this.downloader.retryItem(item);
                    break;
                default:
                    break;
            }
        }
    };
    /**
     * @param {?} item
     * @param {?} status
     * @param {?=} message
     * @return {?}
     */
    DatatransferFacade.prototype.changeItemStatus = /**
     * @param {?} item
     * @param {?} status
     * @param {?=} message
     * @return {?}
     */
    function (item, status, message) {
        if (!!item && !!status) {
            if (item.status !== status) {
                this.paginationService.setPageByItemId(item.id);
                item.status = status;
                if (!!message) {
                    item.message = message;
                }
                this.store.updateFailedCount();
                if (status === TransferStatus.Finished) {
                    document.dispatchEvent(new CustomEvent(CustomEventTypeExtensions.toString(CustomEventType.ITEM_COMPLETED), { detail: item }));
                }
            }
        }
    };
    /**
     * @param {?} item
     * @param {?} progress
     * @return {?}
     */
    DatatransferFacade.prototype.updateItemProgress = /**
     * @param {?} item
     * @param {?} progress
     * @return {?}
     */
    function (item, progress) {
        if (!!item) {
            /** @type {?} */
            var now = this.dateUtil.now();
            /** @type {?} */
            var loaded = item.progressContainer.total * progress;
            item.progressContainer.updateBitrate(now, loaded, this.bitrateInterval);
            item.progressContainer.updateProgress(now, loaded, this.progressInterval);
        }
    };
    /**
     * @param {?} progressContainer
     * @param {?} transferType
     * @param {?} progress
     * @return {?}
     */
    DatatransferFacade.prototype.updateOverallProgress = /**
     * @param {?} progressContainer
     * @param {?} transferType
     * @param {?} progress
     * @return {?}
     */
    function (progressContainer, transferType, progress) {
        /** @type {?} */
        var now = this.dateUtil.now();
        /** @type {?} */
        var loaded = progressContainer.total * progress;
        // this.logger.log('total: ' + progressContainer.total + ' progress: ' + progress + ' loaded: ' + loaded);
        progressContainer.updateBitrate(now, loaded, this.bitrateInterval);
        progressContainer.updateProgress(now, loaded, this.progressInterval);
        if (progressContainer.total > 0 && loaded >= progressContainer.total) {
            switch (transferType) {
                case TransferType.Upload:
                    document.dispatchEvent(new CustomEvent(CustomEventTypeExtensions.toString(CustomEventType.UPLOAD_COMPLETED)));
                    break;
                case TransferType.Download:
                    document.dispatchEvent(new CustomEvent(CustomEventTypeExtensions.toString(CustomEventType.DOWNLOAD_COMPLETED)));
                    break;
                default:
                    break;
            }
        }
    };
    /**
     * @param {?} progressContainer
     * @param {?} size
     * @return {?}
     */
    DatatransferFacade.prototype.updateOverallSize = /**
     * @param {?} progressContainer
     * @param {?} size
     * @return {?}
     */
    function (progressContainer, size) {
        progressContainer.reset(size);
    };
    /**
     * @param {?} filename
     * @param {?} url
     * @param {?} sizeInBytes
     * @return {?}
     */
    DatatransferFacade.prototype.download = /**
     * @param {?} filename
     * @param {?} url
     * @param {?} sizeInBytes
     * @return {?}
     */
    function (filename, url, sizeInBytes) {
        this.downloader.download(filename, url, sizeInBytes);
    };
    /**
     * @param {?} exportType
     * @return {?}
     */
    DatatransferFacade.prototype.export = /**
     * @param {?} exportType
     * @return {?}
     */
    function (exportType) {
        this.exportService.export(exportType);
    };
    /**
     * @param {?} status
     * @return {?}
     */
    DatatransferFacade.prototype.getStatusClass = /**
     * @param {?} status
     * @return {?}
     */
    function (status) {
        switch (status) {
            case TransferStatus.Ready:
                return 'add_circle_outline';
            case TransferStatus.Uploading:
                return 'arrow_upward';
            case TransferStatus.Downloading:
                return 'arrow_downward';
            case TransferStatus.Failed:
                return 'error_outline';
            case TransferStatus.Queued:
            case TransferStatus.Preprocessing:
                return 'schedule';
            case TransferStatus.Finished:
                return 'done_all';
            default:
                return '';
        }
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.showStartButton = /**
     * @return {?}
     */
    function () {
        return this.store.count > 0 && !this.uploader.isWorking() && !this.downloader.isWorking();
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.showPauseButton = /**
     * @return {?}
     */
    function () {
        return this.uploader.isWorking();
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.showRemoveButton = /**
     * @return {?}
     */
    function () {
        return this.store.count > 0;
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.showRetryButton = /**
     * @return {?}
     */
    function () {
        return this.store.failedCount > 0 && !this.uploader.isWorking() && !this.downloader.isWorking();
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.showRetryButtonByItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        return item.status === TransferStatus.Failed;
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.showExportButton = /**
     * @return {?}
     */
    function () {
        return this.store.count > 0;
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.showPreprocessingCheckbox = /**
     * @return {?}
     */
    function () {
        return this.store.count > 0 && ConfigService.settings.core.preprocessHashEnabled;
    };
    /**
     * @return {?}
     */
    DatatransferFacade.prototype.showPreprocessingTooltip = /**
     * @return {?}
     */
    function () {
        return this.showPreprocessingCheckbox() && !!ConfigService.settings.core.preprocessHashTooltipContent;
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.showSpinner = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        return item.preprocessContainer.percent > 0 && item.status === TransferStatus.Preprocessing;
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.showProgressbar = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        return item.progressContainer.percent > 0 &&
            (item.status === TransferStatus.Uploading || item.status === TransferStatus.Downloading);
    };
    /**
     * @param {?} items
     * @param {?} index
     * @return {?}
     */
    DatatransferFacade.prototype.showPath = /**
     * @param {?} items
     * @param {?} index
     * @return {?}
     */
    function (items, index) {
        if (index > 0 && items.length > index) {
            /** @type {?} */
            var currentPath = items[index].path;
            // don't show if previous path is same as current
            return items[index - 1].path !== currentPath;
        }
        return true;
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.showEditDialog = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        /** @type {?} */
        var result = false;
        if (item) {
            switch (item.transferType) {
                case TransferType.Upload:
                    if (item.status === TransferStatus.Ready) {
                        result = true;
                    }
                    break;
                default:
                    break;
            }
        }
        return result;
    };
    /**
     * @param {?} item
     * @param {?} oldPath
     * @param {?} newPath
     * @return {?}
     */
    DatatransferFacade.prototype.editPath = /**
     * @param {?} item
     * @param {?} oldPath
     * @param {?} newPath
     * @return {?}
     */
    function (item, oldPath, newPath) {
        switch (item.transferType) {
            case TransferType.Upload:
                // replace all \ with /
                /** @type {?} */
                var cleanedPath = newPath.replace(/\\/g, '/');
                // replace repeated / with one
                cleanedPath = cleanedPath.replace(/\/+/g, '/');
                if (cleanedPath.startsWith('/')) {
                    cleanedPath = cleanedPath.slice(1);
                }
                if (cleanedPath && !cleanedPath.endsWith('/')) {
                    cleanedPath += '/';
                }
                this.uploader.editPath(oldPath, cleanedPath);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} item
     * @param {?} name
     * @return {?}
     */
    DatatransferFacade.prototype.editFilename = /**
     * @param {?} item
     * @param {?} name
     * @return {?}
     */
    function (item, name) {
        switch (item.transferType) {
            case TransferType.Upload:
                this.uploader.editFilename(item, name);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferFacade.prototype.parseMessage = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (ConfigService.settings.core.parseMessageCallback instanceof Function) {
            return ConfigService.settings.core.parseMessageCallback(item.message);
        }
        else {
            return undefined;
        }
    };
    return DatatransferFacade;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.uploadProgress;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.downloadProgress;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.progressInterval;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.bitrateInterval;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.logger;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.zone;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.store;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.dateUtil;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.paginationService;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.exportService;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.uploader;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.downloader;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacade.prototype.dialog;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/pagination-container.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IPaginationContainer() { }
if (false) {
    /** @type {?} */
    IPaginationContainer.prototype.pages;
    /** @type {?} */
    IPaginationContainer.prototype.page;
    /** @type {?} */
    IPaginationContainer.prototype.rpp;
    /** @type {?} */
    IPaginationContainer.prototype.total;
    /** @type {?} */
    IPaginationContainer.prototype.rppOptions;
}
var PaginationContainer = /** @class */ (function () {
    function PaginationContainer() {
        this.pages = [];
        this.page = 1;
        this.rpp = 5;
        this.total = 0;
    }
    return PaginationContainer;
}());
if (false) {
    /** @type {?} */
    PaginationContainer.prototype.pages;
    /** @type {?} */
    PaginationContainer.prototype.page;
    /** @type {?} */
    PaginationContainer.prototype.rpp;
    /** @type {?} */
    PaginationContainer.prototype.total;
    /** @type {?} */
    PaginationContainer.prototype.rppOptions;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/date.util.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DateUtil = /** @class */ (function () {
    function DateUtil() {
    }
    /**
     * @return {?}
     */
    DateUtil.prototype.now = /**
     * @return {?}
     */
    function () {
        return ((Date.now) ? Date.now() : (new Date()).getTime());
    };
    /**
     * @param {?} seconds
     * @return {?}
     */
    DateUtil.prototype.format = /**
     * @param {?} seconds
     * @return {?}
     */
    function (seconds) {
        /** @type {?} */
        var date = new Date(seconds * 1000);
        if (isNaN(date.getTime())) {
            return undefined;
        }
        else {
            return ('0' + date.getUTCHours()).slice(-2) + ':' +
                ('0' + date.getUTCMinutes()).slice(-2) + ':' +
                ('0' + date.getUTCSeconds()).slice(-2);
        }
    };
    DateUtil.decorators = [
        { type: Injectable }
    ];
    return DateUtil;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/enums/decimal-byte-unit.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var DecimalByteUnit = {
    /**
     * Byte (B)
     * 1 Byte
     */
    Byte: 0,
    /**
     * Kilobyte (kB)
     * 10^3 Byte = 1.000 Byte
     */
    KB: 1,
    /**
     * Megabyte (MB)
     * 10^6 Byte = 1.000.000 Byte
     */
    MB: 2,
    /**
     * Gigabyte (GB)
     * 10^9 Byte = 1.000.000.000 Byte
     */
    GB: 3,
    /**
     * Terabyte (TB)
     * 10^12 Byte = 1.000.000.000.000 Byte
     */
    TB: 4,
    /**
     * Petabyte (PB)
     * 10^15 Byte = 1.000.000.000.000.000 Byte
     */
    PB: 5,
};
DecimalByteUnit[DecimalByteUnit.Byte] = 'Byte';
DecimalByteUnit[DecimalByteUnit.KB] = 'KB';
DecimalByteUnit[DecimalByteUnit.MB] = 'MB';
DecimalByteUnit[DecimalByteUnit.GB] = 'GB';
DecimalByteUnit[DecimalByteUnit.TB] = 'TB';
DecimalByteUnit[DecimalByteUnit.PB] = 'PB';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/extensions/enum.extension.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var 
// @dynamic
EnumExtension = /** @class */ (function () {
    function EnumExtension() {
    }
    /**
     * @template T
     * @param {?} e
     * @return {?}
     */
    EnumExtension.getNamesAndValues = /**
     * @template T
     * @param {?} e
     * @return {?}
     */
    function (e) {
        return this.getNames(e).map((/**
         * @param {?} n
         * @return {?}
         */
        function (n) { return ({ name: n, value: (/** @type {?} */ (e[n])) }); }));
    };
    /**
     * @param {?} e
     * @return {?}
     */
    EnumExtension.getNames = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        return (/** @type {?} */ (this.getObjValues(e).filter((/**
         * @param {?} v
         * @return {?}
         */
        function (v) { return typeof v === 'string'; }))));
    };
    /**
     * @template T
     * @param {?} e
     * @return {?}
     */
    EnumExtension.getValues = /**
     * @template T
     * @param {?} e
     * @return {?}
     */
    function (e) {
        return (/** @type {?} */ (this.getObjValues(e).filter((/**
         * @param {?} v
         * @return {?}
         */
        function (v) { return typeof v === 'number'; }))));
    };
    /**
     * @private
     * @param {?} e
     * @return {?}
     */
    EnumExtension.getObjValues = /**
     * @private
     * @param {?} e
     * @return {?}
     */
    function (e) {
        return Object.keys(e).map((/**
         * @param {?} k
         * @return {?}
         */
        function (k) { return e[k]; }));
    };
    return EnumExtension;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/decimal-byte-unit.util.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DecimalByteUnitUtil = /** @class */ (function () {
    function DecimalByteUnitUtil() {
        this.C_KB = Math.pow(10, 3);
        this.C_MB = Math.pow(10, 6);
        this.C_GB = Math.pow(10, 9);
        this.C_TB = Math.pow(10, 12);
        this.C_PB = Math.pow(10, 15);
        this.MAX = Number.MAX_VALUE;
        this.byteUnits = EnumExtension.getNames(DecimalByteUnit);
    }
    /**
     * @private
     * @param {?} number
     * @param {?} multiplier
     * @return {?}
     */
    DecimalByteUnitUtil.prototype.multiply = /**
     * @private
     * @param {?} number
     * @param {?} multiplier
     * @return {?}
     */
    function (number, multiplier) {
        /** @type {?} */
        var limit = this.MAX / multiplier;
        if (number > limit) {
            return Number.MAX_VALUE;
        }
        if (number < -limit) {
            return Number.MIN_VALUE;
        }
        return number * multiplier;
    };
    /**
     * @param {?} number
     * @param {?} fromUnit
     * @param {?} toUnit
     * @return {?}
     */
    DecimalByteUnitUtil.prototype.convert = /**
     * @param {?} number
     * @param {?} fromUnit
     * @param {?} toUnit
     * @return {?}
     */
    function (number, fromUnit, toUnit) {
        /** @type {?} */
        var bytes = this.toBytes(number, fromUnit);
        switch (toUnit) {
            case DecimalByteUnit.Byte:
                return bytes;
            case DecimalByteUnit.KB:
                return bytes / this.C_KB;
            case DecimalByteUnit.MB:
                return bytes / this.C_MB;
            case DecimalByteUnit.GB:
                return bytes / this.C_GB;
            case DecimalByteUnit.TB:
                return bytes / this.C_TB;
            case DecimalByteUnit.PB:
                return bytes / this.C_PB;
        }
        return number;
    };
    /**
     * @param {?} number
     * @param {?} fromUnit
     * @return {?}
     */
    DecimalByteUnitUtil.prototype.toBytes = /**
     * @param {?} number
     * @param {?} fromUnit
     * @return {?}
     */
    function (number, fromUnit) {
        switch (fromUnit) {
            case DecimalByteUnit.Byte:
                return number;
            case DecimalByteUnit.KB:
                return this.multiply(number, this.C_KB);
            case DecimalByteUnit.MB:
                return this.multiply(number, this.C_MB);
            case DecimalByteUnit.GB:
                return this.multiply(number, this.C_GB);
            case DecimalByteUnit.TB:
                return this.multiply(number, this.C_TB);
            case DecimalByteUnit.PB:
                return this.multiply(number, this.C_PB);
        }
        return number;
    };
    /**
     * @param {?} number
     * @param {?} fromUnit
     * @return {?}
     */
    DecimalByteUnitUtil.prototype.format = /**
     * @param {?} number
     * @param {?} fromUnit
     * @return {?}
     */
    function (number, fromUnit) {
        var e_1, _a;
        /** @type {?} */
        var result;
        result = [DecimalByteUnit.Byte, this.toBytes(number, fromUnit)];
        try {
            for (var _b = __values(this.byteUnits), _c = _b.next(); !_c.done; _c = _b.next()) {
                var currentUnit = _c.value;
                if (Math.abs(result[1]) < 1000) {
                    result[0] = DecimalByteUnit[currentUnit];
                    break;
                }
                else {
                    result[1] /= 1000;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        result[1] = Number(result[1].toFixed(2));
        return result;
    };
    DecimalByteUnitUtil.decorators = [
        { type: Injectable }
    ];
    return DecimalByteUnitUtil;
}());
if (false) {
    /** @type {?} */
    DecimalByteUnitUtil.prototype.C_KB;
    /** @type {?} */
    DecimalByteUnitUtil.prototype.C_MB;
    /** @type {?} */
    DecimalByteUnitUtil.prototype.C_GB;
    /** @type {?} */
    DecimalByteUnitUtil.prototype.C_TB;
    /** @type {?} */
    DecimalByteUnitUtil.prototype.C_PB;
    /** @type {?} */
    DecimalByteUnitUtil.prototype.MAX;
    /** @type {?} */
    DecimalByteUnitUtil.prototype.byteUnits;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/size-container.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ISizeContainer() { }
if (false) {
    /** @type {?} */
    ISizeContainer.prototype.displayUnit;
    /** @type {?} */
    ISizeContainer.prototype.displaySize;
    /** @type {?} */
    ISizeContainer.prototype.decimalByteUnit;
    /** @type {?} */
    ISizeContainer.prototype.decimalByteUnitSize;
    /**
     * @param {?=} init
     * @return {?}
     */
    ISizeContainer.prototype.update = function (init) { };
    /**
     * @param {?} decimalByteUnit
     * @param {?} decimalByteUnitSize
     * @return {?}
     */
    ISizeContainer.prototype.updateDecimal = function (decimalByteUnit, decimalByteUnitSize) { };
}
var SizeContainer = /** @class */ (function () {
    function SizeContainer(init) {
        this.decimalByteUnit = DecimalByteUnit.MB;
        this.decimalByteUnitSize = 0;
        /** @type {?} */
        var injector = ReflectiveInjector.resolveAndCreate([DecimalByteUnitUtil]);
        this.decimalByteUnitUtil = injector.get(DecimalByteUnitUtil);
        this.update(init);
    }
    /**
     * @param {?=} init
     * @return {?}
     */
    SizeContainer.prototype.update = /**
     * @param {?=} init
     * @return {?}
     */
    function (init) {
        if (!!this.decimalByteUnitUtil && !!init && !!init.decimalByteUnitSize) {
            this.updateDecimal(init.decimalByteUnit, init.decimalByteUnitSize);
        }
    };
    /**
     * @param {?} decimalByteUnit
     * @param {?} decimalByteUnitSize
     * @return {?}
     */
    SizeContainer.prototype.updateDecimal = /**
     * @param {?} decimalByteUnit
     * @param {?} decimalByteUnitSize
     * @return {?}
     */
    function (decimalByteUnit, decimalByteUnitSize) {
        /** @type {?} */
        var convertResult = this.decimalByteUnitUtil.format(decimalByteUnitSize, decimalByteUnit);
        this.decimalByteUnit = convertResult[0];
        this.decimalByteUnitSize = convertResult[1];
        this.displayUnit = DecimalByteUnit[this.decimalByteUnit];
        this.displaySize = !!this.decimalByteUnitSize ? this.decimalByteUnitSize : 0;
    };
    return SizeContainer;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    SizeContainer.prototype.decimalByteUnitUtil;
    /** @type {?} */
    SizeContainer.prototype.displayUnit;
    /** @type {?} */
    SizeContainer.prototype.displaySize;
    /** @type {?} */
    SizeContainer.prototype.decimalByteUnit;
    /** @type {?} */
    SizeContainer.prototype.decimalByteUnitSize;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/progress-container.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IProgressContainer() { }
if (false) {
    /** @type {?} */
    IProgressContainer.prototype.total;
    /** @type {?} */
    IProgressContainer.prototype.progressTimestamp;
    /** @type {?} */
    IProgressContainer.prototype.bitrateTimestamp;
    /** @type {?} */
    IProgressContainer.prototype.bitrate;
    /** @type {?} */
    IProgressContainer.prototype.percent;
    /** @type {?} */
    IProgressContainer.prototype.displayBitrate;
    /** @type {?} */
    IProgressContainer.prototype.displayTimeLeft;
    /** @type {?} */
    IProgressContainer.prototype.loadedSizeContainer;
    /** @type {?} */
    IProgressContainer.prototype.totalSizeContainer;
    /**
     * @param {?} total
     * @return {?}
     */
    IProgressContainer.prototype.reset = function (total) { };
    /**
     * @param {?} now
     * @param {?} loaded
     * @param {?} interval
     * @return {?}
     */
    IProgressContainer.prototype.updateProgress = function (now, loaded, interval) { };
    /**
     * @param {?} now
     * @param {?} loaded
     * @param {?} interval
     * @return {?}
     */
    IProgressContainer.prototype.updateBitrate = function (now, loaded, interval) { };
}
var ProgressContainer = /** @class */ (function () {
    function ProgressContainer(total) {
        /** @type {?} */
        var injector = ReflectiveInjector.resolveAndCreate([DateUtil]);
        this.dateUtil = injector.get(DateUtil);
        this.bitrateSizeContainer = new SizeContainer();
        this.loadedSizeContainer = new SizeContainer();
        this.totalSizeContainer = new SizeContainer();
        this.reset(total);
    }
    /**
     * @param {?} total
     * @return {?}
     */
    ProgressContainer.prototype.reset = /**
     * @param {?} total
     * @return {?}
     */
    function (total) {
        this.progressTimestamp = this.dateUtil.now();
        this.bitrateTimestamp = this.dateUtil.now();
        this.loaded = 0;
        this.bitrate = 0;
        this.percent = 0;
        this.total = total;
        this.displayBitrate = undefined;
        this.displayTimeLeft = undefined;
        this.bitrateSizeContainer.updateDecimal(DecimalByteUnit.Byte, this.bitrate);
        this.loadedSizeContainer.updateDecimal(DecimalByteUnit.Byte, this.loaded);
        this.totalSizeContainer.updateDecimal(DecimalByteUnit.Byte, this.total);
    };
    /**
     * @param {?} now
     * @param {?} loaded
     * @param {?} interval
     * @return {?}
     */
    ProgressContainer.prototype.updateProgress = /**
     * @param {?} now
     * @param {?} loaded
     * @param {?} interval
     * @return {?}
     */
    function (now, loaded, interval) {
        /** @type {?} */
        var timeDiff = now - this.progressTimestamp;
        // console.log('loaded: ' + loaded + ' total: ' + this.total);
        if (!this.percent || timeDiff > interval) {
            this.percent = Number((loaded / this.total * 100).toFixed(2));
            this.loaded = loaded;
            this.loadedSizeContainer.updateDecimal(DecimalByteUnit.Byte, this.loaded);
            this.progressTimestamp = now;
            if (this.bitrate > 0) {
                this.displayTimeLeft = this.dateUtil.format((this.total - this.loaded) * 8 / this.bitrate);
            }
            else {
                this.displayTimeLeft = this.dateUtil.format(0);
            }
        }
        else if (loaded >= this.total) {
            this.percent = 100;
            this.loaded = this.total;
        }
    };
    /**
     * @param {?} now
     * @param {?} loaded
     * @param {?} interval
     * @return {?}
     */
    ProgressContainer.prototype.updateBitrate = /**
     * @param {?} now
     * @param {?} loaded
     * @param {?} interval
     * @return {?}
     */
    function (now, loaded, interval) {
        /** @type {?} */
        var timeDiff = now - this.bitrateTimestamp;
        if (!this.bitrate || timeDiff > interval) {
            this.bitrate = (loaded - this.loaded) * (1000 / timeDiff) * 8;
            if (this.bitrate === Number.POSITIVE_INFINITY || this.bitrate === Number.NEGATIVE_INFINITY) {
                this.bitrate = 0;
            }
            this.bitrateSizeContainer.updateDecimal(DecimalByteUnit.Byte, this.bitrate / 8);
            this.displayBitrate = this.bitrateSizeContainer.displaySize + ' ' + this.bitrateSizeContainer.displayUnit + '/s';
            this.bitrateTimestamp = now;
        }
    };
    return ProgressContainer;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ProgressContainer.prototype.dateUtil;
    /**
     * @type {?}
     * @private
     */
    ProgressContainer.prototype.loaded;
    /**
     * @type {?}
     * @private
     */
    ProgressContainer.prototype.bitrateSizeContainer;
    /** @type {?} */
    ProgressContainer.prototype.total;
    /** @type {?} */
    ProgressContainer.prototype.progressTimestamp;
    /** @type {?} */
    ProgressContainer.prototype.bitrateTimestamp;
    /** @type {?} */
    ProgressContainer.prototype.bitrate;
    /** @type {?} */
    ProgressContainer.prototype.percent;
    /** @type {?} */
    ProgressContainer.prototype.displayBitrate;
    /** @type {?} */
    ProgressContainer.prototype.displayTimeLeft;
    /** @type {?} */
    ProgressContainer.prototype.loadedSizeContainer;
    /** @type {?} */
    ProgressContainer.prototype.totalSizeContainer;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/stores/datatransfer.store.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DatatransferStore = /** @class */ (function () {
    function DatatransferStore() {
        this.items = [];
        this.count = 0;
        this.failedCount = 0;
        this.uploadProgress = new ProgressContainer(0);
        this.downloadProgress = new ProgressContainer(0);
    }
    /**
     * @private
     * @return {?}
     */
    DatatransferStore.prototype.updateCount = /**
     * @private
     * @return {?}
     */
    function () {
        this.count = this.items.length;
    };
    /**
     * @return {?}
     */
    DatatransferStore.prototype.updateFailedCount = /**
     * @return {?}
     */
    function () {
        this.failedCount = this.getByStatus(TransferStatus.Failed).length;
    };
    /**
     * @return {?}
     */
    DatatransferStore.prototype.getItems = /**
     * @return {?}
     */
    function () {
        return this.items;
    };
    /**
     * @return {?}
     */
    DatatransferStore.prototype.getSelected = /**
     * @return {?}
     */
    function () {
        return this.items.filter((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.isSelected === true; }));
    };
    /**
     * @param {?} id
     * @return {?}
     */
    DatatransferStore.prototype.getById = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.items.find((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.id === id; }));
    };
    /**
     * @param {?} id
     * @return {?}
     */
    DatatransferStore.prototype.getIndexById = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.items.findIndex((/**
         * @param {?} i
         * @return {?}
         */
        function (i) { return i.id === id; }));
    };
    /**
     * @return {?}
     */
    DatatransferStore.prototype.clear = /**
     * @return {?}
     */
    function () {
        this.items.length = 0;
        this.updateCount();
        this.updateFailedCount();
    };
    /**
     * @param {?} item
     * @return {?}
     */
    DatatransferStore.prototype.addItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        this.items.push(item);
        this.updateCount();
    };
    /**
     * @param {?} id
     * @return {?}
     */
    DatatransferStore.prototype.removeById = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        /** @type {?} */
        var index = this.getIndexById(id);
        if (index > -1) {
            this.items.splice(index, 1);
            this.updateCount();
        }
    };
    /**
     * @param {?} status
     * @return {?}
     */
    DatatransferStore.prototype.getByStatus = /**
     * @param {?} status
     * @return {?}
     */
    function (status) {
        return this.items.filter((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.status === status; }));
    };
    DatatransferStore.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DatatransferStore.ctorParameters = function () { return []; };
    return DatatransferStore;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    DatatransferStore.prototype.items;
    /** @type {?} */
    DatatransferStore.prototype.count;
    /** @type {?} */
    DatatransferStore.prototype.failedCount;
    /** @type {?} */
    DatatransferStore.prototype.uploadProgress;
    /** @type {?} */
    DatatransferStore.prototype.downloadProgress;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/pagination.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PaginationService = /** @class */ (function () {
    function PaginationService(datatransferStore) {
        this.datatransferStore = datatransferStore;
        this.paginatedItems = [];
        this.pagination = new PaginationContainer();
    }
    /**
     * @param {?} rppOptions
     * @return {?}
     */
    PaginationService.prototype.setRppOptions = /**
     * @param {?} rppOptions
     * @return {?}
     */
    function (rppOptions) {
        this.pagination.rppOptions = rppOptions;
        this.setPaginationContainer();
    };
    /**
     * @param {?} total
     * @return {?}
     */
    PaginationService.prototype.update = /**
     * @param {?} total
     * @return {?}
     */
    function (total) {
        if (total <= 0) {
            this.paginatedItems.length = 0;
        }
        this.pagination.total = total;
        this.setPaginationContainer();
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.setPaginationContainer = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var pageCount = this.pageCount();
        if (this.pagination.pages.length > pageCount) {
            this.pagination.pages.splice(pageCount);
        }
        else {
            for (var i = this.pagination.pages.length; i < pageCount; i++) {
                this.pagination.pages.push(i + 1);
            }
        }
        if (!this.pagination.pages.includes(this.pagination.page)) {
            this.pagination.page = 1;
        }
        if (!!this.pagination.rppOptions && this.pagination.rppOptions.length > 0
            && !this.pagination.rppOptions.includes(this.pagination.rpp)) {
            this.pagination.rpp = this.pagination.rppOptions[0];
        }
        this.onPaginationChange();
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.max = /**
     * @return {?}
     */
    function () {
        return this.hasNext() ? this.pagination.page * this.pagination.rpp : this.pagination.total;
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.min = /**
     * @return {?}
     */
    function () {
        return this.pagination.total > 0 ? this.pagination.page * this.pagination.rpp - this.pagination.rpp + 1 : 0;
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.first = /**
     * @return {?}
     */
    function () {
        this.pagination.page = 1;
        this.onPaginationChange();
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.last = /**
     * @return {?}
     */
    function () {
        this.pagination.page = this.pageCount();
        this.onPaginationChange();
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.hasNext = /**
     * @return {?}
     */
    function () {
        return this.pagination.page * this.pagination.rpp < this.pagination.total;
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.hasPrevious = /**
     * @return {?}
     */
    function () {
        return this.pagination.page > 1;
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.moveNext = /**
     * @return {?}
     */
    function () {
        this.pagination.page++;
        this.onPaginationChange();
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.movePrevious = /**
     * @return {?}
     */
    function () {
        this.pagination.page--;
        this.onPaginationChange();
    };
    /**
     * @param {?} page
     * @return {?}
     */
    PaginationService.prototype.setPage = /**
     * @param {?} page
     * @return {?}
     */
    function (page) {
        this.pagination.page = page;
        this.onPageChange();
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.onPageChange = /**
     * @return {?}
     */
    function () {
        this.setPaginationContainer();
        this.onPaginationChange();
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.onRppChange = /**
     * @return {?}
     */
    function () {
        this.setPaginationContainer();
        this.pagination.page = 1;
        this.onPaginationChange();
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.onPaginationChange = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var startIndex = (this.pagination.page - 1) * this.pagination.rpp;
        /** @type {?} */
        var endIndex = Math.min(startIndex + this.pagination.rpp, this.pagination.total);
        this.paginatedItems = this.datatransferStore.getItems().slice(startIndex, endIndex);
    };
    /**
     * @return {?}
     */
    PaginationService.prototype.pageCount = /**
     * @return {?}
     */
    function () {
        return this.pagination.total > 0 ? Math.ceil(this.pagination.total / (this.pagination.rpp > 0 ? this.pagination.rpp : 1)) : 1;
    };
    /**
     * @param {?} id
     * @return {?}
     */
    PaginationService.prototype.getPageByItemId = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        /** @type {?} */
        var index = this.datatransferStore.getIndexById(id);
        if (index > -1) {
            return Math.ceil((index + 1) / this.pagination.rpp);
        }
    };
    /**
     * @param {?} id
     * @return {?}
     */
    PaginationService.prototype.setPageByItemId = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        /** @type {?} */
        var page = this.getPageByItemId(id);
        if (this.pagination.page !== page) {
            this.setPage(page);
        }
    };
    PaginationService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    PaginationService.ctorParameters = function () { return [
        { type: DatatransferStore }
    ]; };
    return PaginationService;
}());
if (false) {
    /** @type {?} */
    PaginationService.prototype.pagination;
    /** @type {?} */
    PaginationService.prototype.paginatedItems;
    /**
     * @type {?}
     * @private
     */
    PaginationService.prototype.datatransferStore;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/main.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MainComponent = /** @class */ (function () {
    function MainComponent(datatransferStore, paginationService) {
        this.datatransferStore = datatransferStore;
        this.paginationService = paginationService;
        this.config = ConfigService.settings;
        this.uploadProgress = this.datatransferStore.uploadProgress;
        this.downloadProgress = this.datatransferStore.downloadProgress;
    }
    /**
     * @return {?}
     */
    MainComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.init();
    };
    /**
     * @private
     * @return {?}
     */
    MainComponent.prototype.init = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.config.core.showUploadDropzone) {
            /** @type {?} */
            var dropzoneElement = document.getElementById('amd-dropzone-component');
            if (dropzoneElement) {
                dropzoneElement.addEventListener('click', this.datatransferFacade.openBrowseDialog.bind(this.datatransferFacade), false);
                this.datatransferFacade.assignUploadDrop(dropzoneElement);
            }
        }
        else {
            if (typeof this.config.core.uploadBrowseElementId !== 'undefined') {
                /** @type {?} */
                var uploadBrowseElement = document.getElementById(this.config.core.uploadBrowseElementId);
                if (uploadBrowseElement) {
                    uploadBrowseElement.addEventListener('click', this.datatransferFacade.openBrowseDialog.bind(this.datatransferFacade), false);
                }
            }
            if (typeof this.config.core.uploadDropElementId !== 'undefined') {
                /** @type {?} */
                var uploadDropElement = document.getElementById(this.config.core.uploadDropElementId);
                if (uploadDropElement) {
                    this.datatransferFacade.assignUploadDrop(uploadDropElement);
                }
            }
        }
    };
    MainComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'amd-main',
                    template: "<div class=\"amd-font\">\r\n    <div *ngIf=\"config.core.showUploadDropzone\">\r\n        <amd-dropzone></amd-dropzone>\r\n    </div>\r\n\r\n    <div fxLayout=\"row\" fxLayout.lt-sm=\"column\" style=\"margin-bottom: 10px\">\r\n        <div fxFlex>\r\n            <button class=\"amd-mr-1\" mat-raised-button *ngIf=\"datatransferFacade.showStartButton()\"\r\n                (click)=\"datatransferFacade.startAll()\">\r\n                <mat-icon>play_arrow</mat-icon> Start\r\n            </button>\r\n            <button class=\"amd-mr-1\" mat-raised-button *ngIf=\"datatransferFacade.showPauseButton()\"\r\n                (click)=\"datatransferFacade.pauseAll()\">\r\n                <mat-icon>pause</mat-icon> Pause\r\n            </button>\r\n            <button class=\"amd-mr-1\" mat-raised-button *ngIf=\"datatransferFacade.showRemoveButton()\"\r\n                (click)=\"datatransferFacade.removeAll()\">\r\n                <mat-icon>close</mat-icon> Remove all\r\n            </button>\r\n            <button class=\"amd-mr-1\" mat-raised-button *ngIf=\"datatransferFacade.showRetryButton()\"\r\n                (click)=\"datatransferFacade.retryAll()\">\r\n                <mat-icon>refresh</mat-icon> Retry ({{datatransferStore.failedCount}})\r\n            </button>\r\n            <mat-menu #exportMenu=\"matMenu\">\r\n                <button mat-menu-item (click)=\"datatransferFacade.export('CSV')\">\r\n                    <span>CSV</span>\r\n                </button>\r\n                <button mat-menu-item (click)=\"datatransferFacade.export('JSON')\">\r\n                    <span>JSON</span>\r\n                </button>\r\n            </mat-menu>\r\n            <button mat-raised-button *ngIf=\"datatransferFacade.showExportButton()\" [matMenuTriggerFor]=\"exportMenu\">\r\n                Export\r\n                <mat-icon>expand_more</mat-icon>\r\n            </button>\r\n            <mat-checkbox *ngIf=\"datatransferFacade.showPreprocessingCheckbox()\"\r\n                [(ngModel)]=\"config.core.preprocessHashChecked\" style=\"margin-left: 10px;\">\r\n                Preprocessing <span *ngIf=\"datatransferFacade.showPreprocessingTooltip()\"\r\n                    class=\"amd-vertical-align-middle\" [matTooltip]=\"config.core.preprocessHashTooltipContent\"\r\n                    matTooltipPosition=\"right\">\r\n                    <mat-icon>info_outline</mat-icon>\r\n                </span>\r\n            </mat-checkbox>\r\n        </div>\r\n        <div fxFlex=\"70px\" fxFlex.lt-sm=\"0px\">\r\n        </div>\r\n        <div fxFlex>\r\n            <div *ngIf=\"uploadProgress.percent > 0\">\r\n                <amd-progress [progressContainer]=\"uploadProgress\"></amd-progress>\r\n            </div>\r\n            <div *ngIf=\"downloadProgress.percent > 0\">\r\n                <amd-progress [progressContainer]=\"downloadProgress\"></amd-progress>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n    <div class=\"amd-container\">\r\n        <div fxLayout=\"row\" class=\"amd-container-header\" style=\"align-items: center;\">\r\n            <div fxFlex=\"40px\">\r\n                <mat-checkbox (change)=\"datatransferFacade.toggleVisible($event.checked)\"></mat-checkbox>\r\n            </div>\r\n            <div fxFlex=\"50%\" fxFlex.lt-sm=\"100%\">\r\n                Filename\r\n            </div>\r\n            <div fxFlex=\"50%\" style=\"padding-left: 40px;\" fxHide.lt-sm>\r\n                Progress\r\n            </div>\r\n            <div fxFlex=\"20px\">\r\n                <mat-menu #batchItemMenu=\"matMenu\">\r\n                    <button mat-menu-item (click)=\"datatransferFacade.removeSelected()\">\r\n                        <mat-icon>close</mat-icon>\r\n                        <span>Remove</span>\r\n                    </button>\r\n                </mat-menu>\r\n                <button mat-icon-button [matMenuTriggerFor]=\"batchItemMenu\">\r\n                    <mat-icon>more_vert</mat-icon>\r\n                </button>\r\n            </div>\r\n        </div>\r\n        <ng-template ngFor let-item [ngForOf]=\"paginationService.paginatedItems\" let-i=\"index\">\r\n            <div *ngIf=\"datatransferFacade.showPath(paginationService.paginatedItems, i)\">\r\n                <div fxLayout=\"row\" class=\"amd-container-headline\">\r\n                    <div fxFlex class=\"amd-container-headline-item\">\r\n                        <div class=\"amd-container-headline-item-entry\">\r\n                            <div fxFlex=\"40px\">\r\n                                <mat-icon>folder_open</mat-icon>\r\n                            </div>\r\n                            <div fxFlex>\r\n                                <span>\r\n                                    <b>{{item.displayPath}}</b>\r\n                                </span>\r\n                                <button mat-icon-button (click)=\"datatransferFacade.openEditPathDialog(item)\"\r\n                                    *ngIf=\"datatransferFacade.showEditDialog(item)\">\r\n                                    <mat-icon aria-label=\"Edit path\">edit</mat-icon>\r\n                                </button>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n            <div fxLayout=\"row\" fxLayout.lt-sm=\"column\" class=\"amd-container-row\"\r\n                [ngClass]=\"{'selected': item.isSelected}\">\r\n                <div fxFlex class=\"amd-container-row-item\">\r\n                    <div class=\"amd-container-row-item-entry\">\r\n                        <div fxFlex=\"40px\">\r\n                            <mat-checkbox [(ngModel)]=\"item.isSelected\"></mat-checkbox>\r\n                        </div>\r\n                        <div fxFlex=\"100%\">\r\n                            <div matTooltip=\"{{item.name}}\" matTooltipPosition=\"above\">\r\n                                <span>{{item.name}}</span>\r\n                                <button mat-icon-button (click)=\"datatransferFacade.openEditFilenameDialog(item)\"\r\n                                    *ngIf=\"datatransferFacade.showEditDialog(item)\">\r\n                                    <mat-icon aria-label=\"Edit filename\">edit</mat-icon>\r\n                                </button>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n                <div fxFlex class=\"amd-container-row-item\">\r\n                    <div class=\"amd-container-row-item-entry\">\r\n                        <div fxFlex=\"40px\" matTooltip=\"{{item.preprocessContainer.percent}}%\"\r\n                            *ngIf=\"datatransferFacade.showSpinner(item); else showStatusClass\">\r\n                            <mat-progress-spinner *ngIf=\"item.preprocessContainer.percent > 0\" [diameter]=\"20\"\r\n                                mode=\"determinate\" [value]=\"item.preprocessContainer.percent\"></mat-progress-spinner>\r\n                        </div>\r\n                        <ng-template #showStatusClass>\r\n                            <div fxFlex=\"40px\">\r\n                                <mat-icon>{{datatransferFacade.getStatusClass(item.status)}}</mat-icon>\r\n                            </div>\r\n                        </ng-template>\r\n                        <div fxFlex=\"100%\">\r\n                            <div *ngIf=\"datatransferFacade.showProgressbar(item); else showStatusBlock\">\r\n                                <div class=\"amd-container-row-item-entry-stats\">\r\n                                    <div fxFlex=\"25%\" fxFlex.lt-md=\"50%\">\r\n                                        {{item.progressContainer.displayBitrate}}\r\n                                    </div>\r\n                                    <div fxFlex=\"25%\" fxHide.lt-md style=\"text-align: center\">\r\n                                        {{item.progressContainer.displayTimeLeft}}\r\n                                    </div>\r\n                                    <div fxFlex=\"25%\" fxHide.lt-md style=\"text-align: center\">\r\n                                        {{item.progressContainer.percent}}%\r\n                                    </div>\r\n                                    <div fxFlex=\"25%\" fxFlex.lt-md=\"50%\" style=\"text-align: right\">\r\n                                        {{item.progressContainer.loadedSizeContainer.displaySize}} /\r\n                                        {{item.sizeContainer.displaySize}}\r\n                                        {{item.sizeContainer.displayUnit}}\r\n                                    </div>\r\n                                </div>\r\n                                <mat-progress-bar *ngIf=\"item.progressContainer.total > 0\" color=\"primary\"\r\n                                    mode=\"determinate\" [value]=\"item.progressContainer.percent\">\r\n                                </mat-progress-bar>\r\n                            </div>\r\n                            <ng-template #showStatusBlock>\r\n                                {{item.getStatusName()}} ({{item.sizeContainer.displaySize}}\r\n                                {{item.sizeContainer.displayUnit}})\r\n                                <div *ngIf=\"!!item.message\">\r\n                                    <small>{{datatransferFacade.parseMessage(item)}}</small>\r\n                                </div>\r\n                            </ng-template>\r\n                        </div>\r\n                        <div fxFlex=\"20px\">\r\n                            <mat-menu #itemMenu=\"matMenu\">\r\n                                <button mat-menu-item (click)=\"datatransferFacade.retryItem(item)\"\r\n                                    *ngIf=\"datatransferFacade.showRetryButtonByItem(item)\">\r\n                                    <mat-icon>refresh</mat-icon>\r\n                                    <span>Retry</span>\r\n                                </button>\r\n                                <button mat-menu-item (click)=\"datatransferFacade.removeItem(item)\">\r\n                                    <mat-icon>close</mat-icon>\r\n                                    <span>Remove</span>\r\n                                </button>\r\n                            </mat-menu>\r\n                            <button mat-icon-button [matMenuTriggerFor]=\"itemMenu\">\r\n                                <mat-icon>more_vert</mat-icon>\r\n                            </button>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ng-template>\r\n    </div>\r\n\r\n    <div style=\"font-size: 12px; margin-top: 20px; text-align: right;\">\r\n        <amd-pagination [paginationService]=\"paginationService\"></amd-pagination>\r\n    </div>\r\n</div>"
                }] }
    ];
    /** @nocollapse */
    MainComponent.ctorParameters = function () { return [
        { type: DatatransferStore },
        { type: PaginationService }
    ]; };
    MainComponent.propDecorators = {
        datatransferFacade: [{ type: Input }]
    };
    return MainComponent;
}());
if (false) {
    /** @type {?} */
    MainComponent.prototype.datatransferFacade;
    /** @type {?} */
    MainComponent.prototype.config;
    /** @type {?} */
    MainComponent.prototype.uploadProgress;
    /** @type {?} */
    MainComponent.prototype.downloadProgress;
    /** @type {?} */
    MainComponent.prototype.datatransferStore;
    /** @type {?} */
    MainComponent.prototype.paginationService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/logger.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// From: https://github.com/angular/angular/issues/5458
var LoggerService = /** @class */ (function () {
    function LoggerService() {
        this.noop = (/**
         * @return {?}
         */
        function () { });
    }
    Object.defineProperty(LoggerService.prototype, "enabled", {
        get: /**
         * @private
         * @return {?}
         */
        function () {
            return !ConfigService.settings.production;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoggerService.prototype, "debug", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.enabled) {
                return console.debug.bind(console);
            }
            return this.noop;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoggerService.prototype, "error", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.enabled) {
                return console.error.bind(console);
            }
            return this.noop;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoggerService.prototype, "log", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.enabled) {
                return console.log.bind(console);
            }
            return this.noop;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoggerService.prototype, "info", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.enabled) {
                return console.info.bind(console);
            }
            return this.noop;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoggerService.prototype, "warn", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.enabled) {
                return console.warn.bind(console);
            }
            return this.noop;
        },
        enumerable: true,
        configurable: true
    });
    LoggerService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    LoggerService.ctorParameters = function () { return []; };
    return LoggerService;
}());
if (false) {
    /** @type {?} */
    LoggerService.prototype.noop;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/io/exporters/base.exporter.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IExporter() { }
if (false) {
    /**
     * @return {?}
     */
    IExporter.prototype.export = function () { };
}
/**
 * @abstract
 */
var BaseExporter = /** @class */ (function () {
    function BaseExporter(logger, store) {
        this.logger = logger;
        this.store = store;
    }
    /**
     * @protected
     * @param {?} content
     * @param {?} fileName
     * @param {?} mimeType
     * @return {?}
     */
    BaseExporter.prototype.download = /**
     * @protected
     * @param {?} content
     * @param {?} fileName
     * @param {?} mimeType
     * @return {?}
     */
    function (content, fileName, mimeType) {
        /** @type {?} */
        var a = document.createElement('a');
        mimeType = mimeType || 'application/octet-stream';
        if (navigator.msSaveBlob) { // IE10
            navigator.msSaveBlob(new Blob([content], {
                type: mimeType
            }), fileName);
        }
        else if (URL && 'download' in a) {
            a.href = URL.createObjectURL(new Blob([content], {
                type: mimeType
            }));
            a.setAttribute('download', fileName);
            document.body.appendChild(a);
            a.click();
            document.body.removeChild(a);
        }
        else {
            location.href = 'data:application/octet-stream,' + encodeURIComponent(content); // only this mime type is supported
        }
    };
    BaseExporter.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    BaseExporter.ctorParameters = function () { return [
        { type: LoggerService },
        { type: DatatransferStore }
    ]; };
    return BaseExporter;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    BaseExporter.prototype.logger;
    /**
     * @type {?}
     * @protected
     */
    BaseExporter.prototype.store;
    /**
     * @abstract
     * @return {?}
     */
    BaseExporter.prototype.export = function () { };
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/io/exporters/csv.exporter.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CsvExporter = /** @class */ (function (_super) {
    __extends(CsvExporter, _super);
    function CsvExporter(logger, store) {
        var _this = _super.call(this, logger, store) || this;
        _this.logger = logger;
        _this.store = store;
        return _this;
    }
    /**
     * @return {?}
     */
    CsvExporter.prototype.export = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var csvContent = 'name,path,status,size,message\n';
        /** @type {?} */
        var items = this.store.getItems();
        items.forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            /** @type {?} */
            var itemString = item.name + ',' + item.path + ',' + item.getStatusName() + ',' + item.sizeContainer.displaySize + ' ' +
                item.sizeContainer.displayUnit + ',' + item.message;
            csvContent += index < items.length ? itemString + '\n' : itemString;
        }));
        this.download(csvContent, 'export.csv', 'text/csv;encoding:utf-8');
    };
    CsvExporter.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    CsvExporter.ctorParameters = function () { return [
        { type: LoggerService },
        { type: DatatransferStore }
    ]; };
    return CsvExporter;
}(BaseExporter));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    CsvExporter.prototype.logger;
    /**
     * @type {?}
     * @protected
     */
    CsvExporter.prototype.store;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/io/exporters/json.exporter.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var JsonExporter = /** @class */ (function (_super) {
    __extends(JsonExporter, _super);
    function JsonExporter(logger, store) {
        var _this = _super.call(this, logger, store) || this;
        _this.logger = logger;
        _this.store = store;
        return _this;
    }
    /**
     * @return {?}
     */
    JsonExporter.prototype.export = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var content = [];
        /** @type {?} */
        var items = this.store.getItems();
        items.forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            content.push({
                name: item.name,
                path: item.path,
                status: item.getStatusName(),
                size: item.sizeContainer.displaySize + ' ' + item.sizeContainer.displayUnit,
                message: item.message
            });
        }));
        this.download(JSON.stringify(content, null, '\t'), 'export.json', 'text/json;encoding:utf-8');
    };
    JsonExporter.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    JsonExporter.ctorParameters = function () { return [
        { type: LoggerService },
        { type: DatatransferStore }
    ]; };
    return JsonExporter;
}(BaseExporter));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    JsonExporter.prototype.logger;
    /**
     * @type {?}
     * @protected
     */
    JsonExporter.prototype.store;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/enums/export-type.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var ExportType = {
    CSV: 0,
    JSON: 1,
};
ExportType[ExportType.CSV] = 'CSV';
ExportType[ExportType.JSON] = 'JSON';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/export.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ExportService = /** @class */ (function () {
    function ExportService(csvExporter, jsonExporter) {
        this.csvExporter = csvExporter;
        this.jsonExporter = jsonExporter;
    }
    /**
     * @param {?} exportType
     * @return {?}
     */
    ExportService.prototype.export = /**
     * @param {?} exportType
     * @return {?}
     */
    function (exportType) {
        /** @type {?} */
        var castedExportType = ExportType[exportType];
        switch (castedExportType) {
            case ExportType.CSV:
                this.csvExporter.export();
                break;
            case ExportType.JSON:
                this.jsonExporter.export();
                break;
            default:
                break;
        }
    };
    ExportService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ExportService.ctorParameters = function () { return [
        { type: CsvExporter },
        { type: JsonExporter }
    ]; };
    return ExportService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ExportService.prototype.csvExporter;
    /**
     * @type {?}
     * @private
     */
    ExportService.prototype.jsonExporter;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/preprocess-container.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IPreprocessContainer() { }
if (false) {
    /** @type {?} */
    IPreprocessContainer.prototype.percent;
    /**
     * @param {?} pause
     * @return {?}
     */
    IPreprocessContainer.prototype.pause = function (pause) { };
    /**
     * @return {?}
     */
    IPreprocessContainer.prototype.isPaused = function () { };
    /**
     * @param {?} cancel
     * @return {?}
     */
    IPreprocessContainer.prototype.cancel = function (cancel) { };
    /**
     * @return {?}
     */
    IPreprocessContainer.prototype.isCancelled = function () { };
    /**
     * @return {?}
     */
    IPreprocessContainer.prototype.doWork = function () { };
    /**
     * @return {?}
     */
    IPreprocessContainer.prototype.run = function () { };
}
var PreprocessContainer = /** @class */ (function () {
    function PreprocessContainer(init) {
        this.percent = 0;
        this._isPaused = false;
        this._isCancelled = false;
        Object.assign(this, init);
    }
    /**
     * @param {?} pause
     * @return {?}
     */
    PreprocessContainer.prototype.pause = /**
     * @param {?} pause
     * @return {?}
     */
    function (pause) {
        this._isPaused = pause;
    };
    /**
     * @return {?}
     */
    PreprocessContainer.prototype.isPaused = /**
     * @return {?}
     */
    function () {
        return this._isPaused;
    };
    /**
     * @param {?} cancel
     * @return {?}
     */
    PreprocessContainer.prototype.cancel = /**
     * @param {?} cancel
     * @return {?}
     */
    function (cancel) {
        this._isCancelled = cancel;
    };
    /**
     * @return {?}
     */
    PreprocessContainer.prototype.isCancelled = /**
     * @return {?}
     */
    function () {
        return this._isCancelled;
    };
    /**
     * @return {?}
     */
    PreprocessContainer.prototype.doWork = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    PreprocessContainer.prototype.run = /**
     * @return {?}
     */
    function () {
        this._isPaused = false;
        this.doWork();
    };
    return PreprocessContainer;
}());
if (false) {
    /** @type {?} */
    PreprocessContainer.prototype.percent;
    /**
     * @type {?}
     * @private
     */
    PreprocessContainer.prototype._isPaused;
    /**
     * @type {?}
     * @private
     */
    PreprocessContainer.prototype._isCancelled;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/enums/hash-type.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var HashType = {
    MD5: 0,
    SHA1: 1,
};
HashType[HashType.MD5] = 'MD5';
HashType[HashType.SHA1] = 'SHA1';
/** @enum {number} */
var HashTypeImplementation = {
    Internal: 0,
    CryptoBrowserify: 1,
};
HashTypeImplementation[HashTypeImplementation.Internal] = 'Internal';
HashTypeImplementation[HashTypeImplementation.CryptoBrowserify] = 'CryptoBrowserify';
// tslint:disable-next-line: no-namespace
var HashTypeExtensions;
(function (HashTypeExtensions) {
    /**
     * @param {?} hashTypeImplementation
     * @param {?} hashType
     * @return {?}
     */
    function toString(hashTypeImplementation, hashType) {
        switch (hashType) {
            case HashType.MD5:
                return 'md5';
            case HashType.SHA1:
                return 'sha1';
            default:
                return 'sha1';
        }
    }
    HashTypeExtensions.toString = toString;
    /**
     * @param {?} hashTypeImplementation
     * @param {?} hashType
     * @return {?}
     */
    function toEnum(hashTypeImplementation, hashType) {
        switch (hashType) {
            case 'md5':
                return HashType.MD5;
            case 'sha1':
                return HashType.SHA1;
            default:
                return HashType.SHA1;
        }
    }
    HashTypeExtensions.toEnum = toEnum;
})(HashTypeExtensions || (HashTypeExtensions = {}));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/enums/encoding-type.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var EncodingType = {
    Latin1: 0,
    Hex: 1,
    Base64: 2,
    UTF8: 3,
};
EncodingType[EncodingType.Latin1] = 'Latin1';
EncodingType[EncodingType.Hex] = 'Hex';
EncodingType[EncodingType.Base64] = 'Base64';
EncodingType[EncodingType.UTF8] = 'UTF8';
/** @enum {number} */
var EncodingTypeImplementation = {
    Internal: 0,
    CryptoBrowserify: 1,
};
EncodingTypeImplementation[EncodingTypeImplementation.Internal] = 'Internal';
EncodingTypeImplementation[EncodingTypeImplementation.CryptoBrowserify] = 'CryptoBrowserify';
// tslint:disable-next-line: no-namespace
var EncodingTypeExtensions;
(function (EncodingTypeExtensions) {
    /**
     * @param {?} encodingTypeImplementation
     * @param {?} encodingType
     * @return {?}
     */
    function toString(encodingTypeImplementation, encodingType) {
        switch (encodingType) {
            case EncodingType.Latin1:
                return 'latin1';
            case EncodingType.Hex:
                return 'hex';
            case EncodingType.Base64:
                return 'base64';
            case EncodingType.UTF8:
                return 'utf8';
            default:
                return 'hex';
        }
    }
    EncodingTypeExtensions.toString = toString;
    /**
     * @param {?} encodingTypeImplementation
     * @param {?} encodingType
     * @return {?}
     */
    function toEnum(encodingTypeImplementation, encodingType) {
        switch (encodingType) {
            case 'latin1':
                return EncodingType.Latin1;
            case 'hex':
                return EncodingType.Hex;
            case 'base64':
                return EncodingType.Base64;
            case 'utf8':
                return EncodingType.UTF8;
            default:
                return EncodingType.Hex;
        }
    }
    EncodingTypeExtensions.toEnum = toEnum;
})(EncodingTypeExtensions || (EncodingTypeExtensions = {}));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/hash-container.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IHashContainer() { }
if (false) {
    /** @type {?} */
    IHashContainer.prototype.file;
    /** @type {?} */
    IHashContainer.prototype.hashType;
    /** @type {?} */
    IHashContainer.prototype.hashTypeString;
    /** @type {?} */
    IHashContainer.prototype.encodingType;
    /** @type {?} */
    IHashContainer.prototype.encodingTypeString;
    /** @type {?} */
    IHashContainer.prototype.inputEncodingType;
    /** @type {?} */
    IHashContainer.prototype.inputEncodingTypeString;
    /** @type {?} */
    IHashContainer.prototype.startDate;
    /** @type {?} */
    IHashContainer.prototype.endDate;
    /** @type {?} */
    IHashContainer.prototype.hash;
    /** @type {?} */
    IHashContainer.prototype.hashString;
    /** @type {?} */
    IHashContainer.prototype.reader;
}
/**
 * @record
 */
function IStreamHashContainer() { }
if (false) {
    /** @type {?} */
    IStreamHashContainer.prototype.chunkSize;
    /** @type {?} */
    IStreamHashContainer.prototype.offset;
}
var HashContainer = /** @class */ (function (_super) {
    __extends(HashContainer, _super);
    function HashContainer(file, hashTypeImplementation, encodingTypeImplementation, hashType, encodingType, inputEncodingType) {
        var _this = _super.call(this) || this;
        _this.file = file;
        _this.hashType = hashType;
        _this.hashTypeString = HashTypeExtensions.toString(hashTypeImplementation, hashType);
        _this.encodingType = encodingType;
        _this.encodingTypeString = EncodingTypeExtensions.toString(encodingTypeImplementation, encodingType);
        _this.inputEncodingType = inputEncodingType;
        _this.inputEncodingTypeString = EncodingTypeExtensions.toString(encodingTypeImplementation, inputEncodingType);
        _this.startDate = new Date();
        _this.endDate = new Date();
        _this.reader = new FileReader();
        return _this;
    }
    return HashContainer;
}(PreprocessContainer));
if (false) {
    /** @type {?} */
    HashContainer.prototype.file;
    /** @type {?} */
    HashContainer.prototype.hashType;
    /** @type {?} */
    HashContainer.prototype.hashTypeString;
    /** @type {?} */
    HashContainer.prototype.encodingType;
    /** @type {?} */
    HashContainer.prototype.encodingTypeString;
    /** @type {?} */
    HashContainer.prototype.inputEncodingType;
    /** @type {?} */
    HashContainer.prototype.inputEncodingTypeString;
    /** @type {?} */
    HashContainer.prototype.startDate;
    /** @type {?} */
    HashContainer.prototype.endDate;
    /** @type {?} */
    HashContainer.prototype.hash;
    /** @type {?} */
    HashContainer.prototype.hashString;
    /** @type {?} */
    HashContainer.prototype.reader;
}
var StreamHashContainer = /** @class */ (function (_super) {
    __extends(StreamHashContainer, _super);
    function StreamHashContainer(file, hashTypeImplementation, encodingTypeImplementation, hashType, encodingType, inputEncodingType) {
        var _this = _super.call(this, file, hashTypeImplementation, encodingTypeImplementation, hashType, encodingType, inputEncodingType) || this;
        _this.chunkSize = 0;
        _this.offset = 0;
        return _this;
    }
    /**
     * @param {?} cancel
     * @return {?}
     */
    StreamHashContainer.prototype.cancel = /**
     * @param {?} cancel
     * @return {?}
     */
    function (cancel) {
        _super.prototype.cancel.call(this, cancel);
        this.offset = 0;
    };
    return StreamHashContainer;
}(HashContainer));
if (false) {
    /** @type {?} */
    StreamHashContainer.prototype.chunkSize;
    /** @type {?} */
    StreamHashContainer.prototype.offset;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/io/datatransfer.io.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IDatatransfer() { }
if (false) {
    /**
     * @param {?} event
     * @param {?} callback
     * @return {?}
     */
    IDatatransfer.prototype.on = function (event, callback) { };
    /**
     * @return {?}
     */
    IDatatransfer.prototype.isWorking = function () { };
    /**
     * @return {?}
     */
    IDatatransfer.prototype.startAll = function () { };
    /**
     * @return {?}
     */
    IDatatransfer.prototype.pauseAll = function () { };
    /**
     * @return {?}
     */
    IDatatransfer.prototype.removeAll = function () { };
    /**
     * @param {?} item
     * @return {?}
     */
    IDatatransfer.prototype.addItem = function (item) { };
    /**
     * @param {?} item
     * @return {?}
     */
    IDatatransfer.prototype.removeItem = function (item) { };
    /**
     * @param {?} item
     * @return {?}
     */
    IDatatransfer.prototype.retryItem = function (item) { };
}
/**
 * @abstract
 */
var  /**
 * @abstract
 */
BaseDatatransfer = /** @class */ (function () {
    function BaseDatatransfer(logger, guidUtil, cryptoService) {
        this.logger = logger;
        this.guidUtil = guidUtil;
        this.cryptoService = cryptoService;
        this.events = [];
        this._isWorking = false;
    }
    /**
     * @param {?} event
     * @param {?} callback
     * @return {?}
     */
    BaseDatatransfer.prototype.on = /**
     * @param {?} event
     * @param {?} callback
     * @return {?}
     */
    function (event, callback) {
        this.events.push(event.toLowerCase(), callback);
    };
    /**
     * @protected
     * @param {...?} args
     * @return {?}
     */
    BaseDatatransfer.prototype.fire = /**
     * @protected
     * @param {...?} args
     * @return {?}
     */
    function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        /** @type {?} */
        var event = args[0].toLowerCase();
        // Find event listeners, and support pseudo-event `catchAll`
        for (var i = 0; i <= this.events.length; i += 2) {
            if (this.events[i] === event) {
                this.events[i + 1].apply(this, args.slice(1));
            }
            if (this.events[i] === 'catchall') {
                this.events[i + 1].apply(null, args);
            }
        }
    };
    /**
     * @protected
     * @return {?}
     */
    BaseDatatransfer.prototype.updateZone = /**
     * @protected
     * @return {?}
     */
    function () {
        this.fire('zoneUpdated');
    };
    /**
     * @protected
     * @param {?} item
     * @param {?} status
     * @param {?=} message
     * @return {?}
     */
    BaseDatatransfer.prototype.changeItemStatus = /**
     * @protected
     * @param {?} item
     * @param {?} status
     * @param {?=} message
     * @return {?}
     */
    function (item, status, message) {
        this.fire('itemStatusChanged', item, status, message);
    };
    /**
     * @protected
     * @param {?} item
     * @param {?} progress
     * @return {?}
     */
    BaseDatatransfer.prototype.updateItemProgress = /**
     * @protected
     * @param {?} item
     * @param {?} progress
     * @return {?}
     */
    function (item, progress) {
        this.fire('itemProgressUpdated', item, progress);
    };
    /**
     * @protected
     * @param {?} transferType
     * @param {?} progress
     * @return {?}
     */
    BaseDatatransfer.prototype.updateOverallProgress = /**
     * @protected
     * @param {?} transferType
     * @param {?} progress
     * @return {?}
     */
    function (transferType, progress) {
        this.fire('overallProgressUpdated', transferType, progress);
    };
    /**
     * @protected
     * @param {?} size
     * @return {?}
     */
    BaseDatatransfer.prototype.updateOverallSize = /**
     * @protected
     * @param {?} size
     * @return {?}
     */
    function (size) {
        this.fire('overallSizeUpdated', size);
    };
    /**
     * @return {?}
     */
    BaseDatatransfer.prototype.isWorking = /**
     * @return {?}
     */
    function () {
        return this._isWorking;
    };
    /**
     * @param {?} item
     * @return {?}
     */
    BaseDatatransfer.prototype.addItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        this.fire('itemAdded', item);
    };
    /**
     * @protected
     * @return {?}
     */
    BaseDatatransfer.prototype.generateUniqueIdentifier = /**
     * @protected
     * @return {?}
     */
    function () {
        return this.guidUtil.createGuid();
    };
    /**
     * @protected
     * @param {?} item
     * @param {?} file
     * @param {?} continueCallback
     * @param {?} cancelCallback
     * @return {?}
     */
    BaseDatatransfer.prototype.preprocessHash = /**
     * @protected
     * @param {?} item
     * @param {?} file
     * @param {?} continueCallback
     * @param {?} cancelCallback
     * @return {?}
     */
    function (item, file, continueCallback, cancelCallback) {
        /** @type {?} */
        var successCallback = (/**
         * @param {?} container
         * @return {?}
         */
        function (container) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            if (container.hashString) {
                // const seconds = (container.endDate.getTime() - container.startDate.getTime()) / 1000;
                // console.log('file hashing took ' + seconds + ' seconds');
                /** @type {?} */
                var xhr_1 = new XMLHttpRequest();
                /** @type {?} */
                var responseHandler = (/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) {
                    // ignore response if container has been cancelled
                    if (!container.isCancelled()) {
                        if (xhr_1.status === 200) {
                            item.message = xhr_1.responseText;
                            cancelCallback();
                        }
                        else {
                            continueCallback();
                        }
                    }
                });
                xhr_1.addEventListener('load', responseHandler, false);
                xhr_1.addEventListener('error', responseHandler, false);
                xhr_1.addEventListener('timeout', responseHandler, false);
                /** @type {?} */
                var params = [];
                params = params.concat([
                    [ConfigService.settings.core.preprocessHashParameterName, container.hashString],
                    [ConfigService.settings.core.preprocessHashFileNameParameterName, item.name]
                ]
                    .map((/**
                 * @param {?} pair
                 * @return {?}
                 */
                function (pair) {
                    return [
                        pair[0], encodeURIComponent(pair[1])
                    ].join('=');
                })));
                xhr_1.open(ConfigService.settings.core.preprocessHashMethod, ConfigService.settings.core.getTarget('preprocessHash', params));
                xhr_1.send(null);
            }
            else {
                continueCallback();
            }
        }).bind(this);
        /** @type {?} */
        var errorCallback = (/**
         * @param {?} event
         * @param {?} container
         * @return {?}
         */
        function (event, container) {
            console.log(event);
            continueCallback();
        });
        if (!item.preprocessContainer.isCancelled() && item.preprocessContainer instanceof StreamHashContainer) {
            // continue
        }
        else {
            /** @type {?} */
            var hashType = HashTypeExtensions.toEnum(HashTypeImplementation.Internal, ConfigService.settings.core.preprocessHashFunctionName);
            /** @type {?} */
            var encodingType = EncodingTypeExtensions.toEnum(EncodingTypeImplementation.Internal, ConfigService.settings.core.preprocessHashEncodingName);
            /** @type {?} */
            var inputEncodingType = EncodingTypeExtensions.toEnum(EncodingTypeImplementation.Internal, ConfigService.settings.core.preprocessHashInputEncodingName);
            item.preprocessContainer = this.cryptoService.createStreamHashContainer(file, hashType, encodingType, inputEncodingType, successCallback, errorCallback);
        }
        // wait for the initial mat-progress-spinner animation to complete
        setTimeout((/**
         * @return {?}
         */
        function () {
            item.preprocessContainer.run();
        }), 1000);
    };
    return BaseDatatransfer;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BaseDatatransfer.prototype.events;
    /**
     * @type {?}
     * @protected
     */
    BaseDatatransfer.prototype._isWorking;
    /**
     * @type {?}
     * @protected
     */
    BaseDatatransfer.prototype.logger;
    /**
     * @type {?}
     * @protected
     */
    BaseDatatransfer.prototype.guidUtil;
    /**
     * @type {?}
     * @protected
     */
    BaseDatatransfer.prototype.cryptoService;
    /**
     * @abstract
     * @return {?}
     */
    BaseDatatransfer.prototype.startAll = function () { };
    /**
     * @abstract
     * @return {?}
     */
    BaseDatatransfer.prototype.pauseAll = function () { };
    /**
     * @abstract
     * @return {?}
     */
    BaseDatatransfer.prototype.removeAll = function () { };
    /**
     * @abstract
     * @param {?} item
     * @return {?}
     */
    BaseDatatransfer.prototype.removeItem = function (item) { };
    /**
     * @abstract
     * @param {?} item
     * @return {?}
     */
    BaseDatatransfer.prototype.retryItem = function (item) { };
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/io/uploaders/base.uploader.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IUploader() { }
if (false) {
    /**
     * @param {?} element
     * @param {?} isDirectory
     * @return {?}
     */
    IUploader.prototype.assignBrowse = function (element, isDirectory) { };
    /**
     * @param {?} element
     * @return {?}
     */
    IUploader.prototype.assignDrop = function (element) { };
    /**
     * @param {?} oldPath
     * @param {?} newPath
     * @return {?}
     */
    IUploader.prototype.editPath = function (oldPath, newPath) { };
    /**
     * @param {?} item
     * @param {?} name
     * @return {?}
     */
    IUploader.prototype.editFilename = function (item, name) { };
}
/**
 * @abstract
 */
var  /**
 * @abstract
 */
BaseUploader = /** @class */ (function (_super) {
    __extends(BaseUploader, _super);
    function BaseUploader(logger, guidUtil, cryptoService) {
        var _this = _super.call(this, logger, guidUtil, cryptoService) || this;
        _this.logger = logger;
        _this.guidUtil = guidUtil;
        _this.cryptoService = cryptoService;
        _this.filenameRegExp = new RegExp('[\/\\\\*?"<>:|]');
        _this.pathRegExp = new RegExp('[*?"<>:|]');
        _this.transferType = TransferType.Upload;
        return _this;
    }
    /**
     * @param {?} oldPath
     * @param {?} newPath
     * @return {?}
     */
    BaseUploader.prototype.editPath = /**
     * @param {?} oldPath
     * @param {?} newPath
     * @return {?}
     */
    function (oldPath, newPath) {
        if (this.pathRegExp.test(newPath)) {
            throw new Error('A path cannot contain any of the following characters: * ? " < > : |');
        }
    };
    /**
     * @param {?} item
     * @param {?} name
     * @return {?}
     */
    BaseUploader.prototype.editFilename = /**
     * @param {?} item
     * @param {?} name
     * @return {?}
     */
    function (item, name) {
        if (!item) {
            throw new Error('Cannot edit the filename.');
        }
        if (!name) {
            throw new Error('Empty filename is not allowed.');
        }
        if (this.filenameRegExp.test(name)) {
            throw new Error('A filename cannot contain any of the following characters: \\ / * ? " < > : |');
        }
    };
    return BaseUploader;
}(BaseDatatransfer));
if (false) {
    /**
     * @type {?}
     * @private
     */
    BaseUploader.prototype.filenameRegExp;
    /**
     * @type {?}
     * @private
     */
    BaseUploader.prototype.pathRegExp;
    /**
     * @type {?}
     * @protected
     */
    BaseUploader.prototype.transferType;
    /**
     * @type {?}
     * @protected
     */
    BaseUploader.prototype.logger;
    /**
     * @type {?}
     * @protected
     */
    BaseUploader.prototype.guidUtil;
    /**
     * @type {?}
     * @protected
     */
    BaseUploader.prototype.cryptoService;
    /**
     * @abstract
     * @param {?} element
     * @param {?} isDirectory
     * @return {?}
     */
    BaseUploader.prototype.assignBrowse = function (element, isDirectory) { };
    /**
     * @abstract
     * @param {?} element
     * @return {?}
     */
    BaseUploader.prototype.assignDrop = function (element) { };
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/guid.util.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var GuidUtil = /** @class */ (function () {
    function GuidUtil() {
    }
    /**
     * @return {?}
     */
    GuidUtil.prototype.createGuid = /**
     * @return {?}
     */
    function () {
        /**
         * @return {?}
         */
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
        }
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
    };
    GuidUtil.decorators = [
        { type: Injectable }
    ];
    return GuidUtil;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/crypto.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CryptoService = /** @class */ (function () {
    function CryptoService(zone) {
        this.zone = zone;
        // hash 4MB at a time
        this.STREAM_HASH_CHUNK_SIZE = 1024 * 1000 * 4;
        this.HASH_TYPE_IMPLEMENTATION = HashTypeImplementation.CryptoBrowserify;
        this.ENCODING_TYPE_IMPLEMENTATION = EncodingTypeImplementation.CryptoBrowserify;
        // Performance remains unchanged by running the hash function outside of Angular.
        // this.zone.runOutsideAngular(() => { }
    }
    /**
     * @param {?} file
     * @param {?} hashType
     * @param {?} encodingType
     * @param {?} inputEncodingType
     * @return {?}
     */
    CryptoService.prototype.createHashContainer = /**
     * @param {?} file
     * @param {?} hashType
     * @param {?} encodingType
     * @param {?} inputEncodingType
     * @return {?}
     */
    function (file, hashType, encodingType, inputEncodingType) {
        /** @type {?} */
        var container = new HashContainer(file, this.HASH_TYPE_IMPLEMENTATION, this.ENCODING_TYPE_IMPLEMENTATION, hashType, encodingType, inputEncodingType);
        container.hash = createHash(container.hashTypeString);
        container.reader.onload = (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            container.hashString = container.hash.update(event.target.result, container.inputEncodingTypeString)
                .digest(container.encodingTypeString);
            container.endDate = new Date();
            container.percent = 100;
        }).bind(container);
        container.doWork = (/**
         * @return {?}
         */
        function () {
            container.reader.readAsBinaryString(container.file);
        });
        return container;
    };
    /**
     * @param {?} file
     * @param {?} hashType
     * @param {?} encodingType
     * @param {?} inputEncodingType
     * @param {?} successCallback
     * @param {?} errorCallback
     * @return {?}
     */
    CryptoService.prototype.createStreamHashContainer = /**
     * @param {?} file
     * @param {?} hashType
     * @param {?} encodingType
     * @param {?} inputEncodingType
     * @param {?} successCallback
     * @param {?} errorCallback
     * @return {?}
     */
    function (file, hashType, encodingType, inputEncodingType, successCallback, errorCallback) {
        /** @type {?} */
        var container = new StreamHashContainer(file, this.HASH_TYPE_IMPLEMENTATION, this.ENCODING_TYPE_IMPLEMENTATION, hashType, encodingType, inputEncodingType);
        container.chunkSize = this.STREAM_HASH_CHUNK_SIZE;
        container.offset = 0;
        container.hash = createHash(container.hashTypeString);
        container.reader.onload = (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var binary = event.target.result;
            if (container.offset + container.chunkSize >= container.file.size) {
                container.hash.end(binary, container.inputEncodingTypeString);
            }
            else {
                container.hash.write(binary, container.inputEncodingTypeString);
            }
            container.offset += container.chunkSize;
            container.doWork();
        }).bind(container);
        container.reader.onerror = (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            errorCallback(event, container);
        });
        container.doWork = (/**
         * @return {?}
         */
        function () {
            if (!container.isCancelled() && !container.isPaused()) {
                if (container.offset > container.file.size) {
                    container.hashString = container.hash.read().toString(container.encodingTypeString);
                    container.endDate = new Date();
                    container.percent = 100;
                    successCallback(container);
                    return;
                }
                /** @type {?} */
                var slice = container.file.slice(container.offset, container.offset + container.chunkSize);
                container.reader.readAsBinaryString(slice);
                container.percent = Math.round(container.offset / file.size * 100);
            }
        });
        return container;
    };
    CryptoService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    CryptoService.ctorParameters = function () { return [
        { type: NgZone }
    ]; };
    return CryptoService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    CryptoService.prototype.STREAM_HASH_CHUNK_SIZE;
    /**
     * @type {?}
     * @private
     */
    CryptoService.prototype.HASH_TYPE_IMPLEMENTATION;
    /**
     * @type {?}
     * @private
     */
    CryptoService.prototype.ENCODING_TYPE_IMPLEMENTATION;
    /**
     * @type {?}
     * @private
     */
    CryptoService.prototype.zone;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/datatransfer-item.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IDatatransferItem() { }
if (false) {
    /** @type {?} */
    IDatatransferItem.prototype.id;
    /** @type {?} */
    IDatatransferItem.prototype.name;
    /** @type {?} */
    IDatatransferItem.prototype.path;
    /** @type {?} */
    IDatatransferItem.prototype.displayPath;
    /** @type {?} */
    IDatatransferItem.prototype.sizeContainer;
    /** @type {?} */
    IDatatransferItem.prototype.transferType;
    /** @type {?} */
    IDatatransferItem.prototype.status;
    /** @type {?} */
    IDatatransferItem.prototype.preprocessContainer;
    /** @type {?} */
    IDatatransferItem.prototype.progressContainer;
    /** @type {?|undefined} */
    IDatatransferItem.prototype.message;
    /** @type {?|undefined} */
    IDatatransferItem.prototype.isSelected;
    /** @type {?|undefined} */
    IDatatransferItem.prototype.externalItem;
    /**
     * @return {?}
     */
    IDatatransferItem.prototype.getStatusName = function () { };
    /**
     * @return {?}
     */
    IDatatransferItem.prototype.getTransferTypeName = function () { };
}
var DatatransferItem = /** @class */ (function () {
    function DatatransferItem(init) {
        this.sizeContainer = new SizeContainer();
        this.preprocessContainer = new PreprocessContainer();
        this.progressContainer = new ProgressContainer(0);
        Object.assign(this, init);
    }
    Object.defineProperty(DatatransferItem.prototype, "path", {
        get: /**
         * @return {?}
         */
        function () {
            return this._path;
        },
        set: /**
         * @param {?} newPath
         * @return {?}
         */
        function (newPath) {
            this._path = newPath;
            this.displayPath = newPath;
            if (this.displayPath) {
                // remove last character
                if (this.displayPath.endsWith('/')) {
                    this.displayPath = this.displayPath.slice(0, -1);
                }
                // replace all '/' with ' > '
                this.displayPath = this.displayPath.replace(/\//g, ' > ');
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatatransferItem.prototype, "message", {
        get: /**
         * @return {?}
         */
        function () {
            return this._message;
        },
        set: /**
         * @param {?} newMessage
         * @return {?}
         */
        function (newMessage) {
            this._message = newMessage.toLowerCase().startsWith('<!doctype html') ? undefined : newMessage;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    DatatransferItem.prototype.getStatusName = /**
     * @return {?}
     */
    function () {
        return TransferStatus[this.status];
    };
    /**
     * @return {?}
     */
    DatatransferItem.prototype.getTransferTypeName = /**
     * @return {?}
     */
    function () {
        return TransferType[this.transferType];
    };
    return DatatransferItem;
}());
if (false) {
    /** @type {?} */
    DatatransferItem.prototype.id;
    /** @type {?} */
    DatatransferItem.prototype.name;
    /**
     * @type {?}
     * @private
     */
    DatatransferItem.prototype._path;
    /** @type {?} */
    DatatransferItem.prototype.displayPath;
    /** @type {?} */
    DatatransferItem.prototype.sizeContainer;
    /** @type {?} */
    DatatransferItem.prototype.transferType;
    /** @type {?} */
    DatatransferItem.prototype.status;
    /** @type {?} */
    DatatransferItem.prototype.preprocessContainer;
    /** @type {?} */
    DatatransferItem.prototype.progressContainer;
    /**
     * @type {?}
     * @private
     */
    DatatransferItem.prototype._message;
    /** @type {?} */
    DatatransferItem.prototype.string;
    /** @type {?} */
    DatatransferItem.prototype.isSelected;
    /** @type {?} */
    DatatransferItem.prototype.externalItem;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/io/uploaders/resumablejs.uploader.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ResumableJsUploader = /** @class */ (function (_super) {
    __extends(ResumableJsUploader, _super);
    function ResumableJsUploader(logger, guidUtil, cryptoService) {
        var _this = _super.call(this, logger, guidUtil, cryptoService) || this;
        _this.logger = logger;
        _this.guidUtil = guidUtil;
        _this.cryptoService = cryptoService;
        _this.r = undefined;
        _this.preprocessFileFn = undefined;
        _this.preprocessChunkFn = undefined;
        _this.initResumable();
        return _this;
    }
    /**
     * @private
     * @return {?}
     */
    ResumableJsUploader.prototype.initResumable = /**
     * @private
     * @return {?}
     */
    function () {
        /**
         * @param {?} file
         * @param {?} event
         * @return {?}
         */
        function generateId(file, event) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            return that.generateUniqueIdentifier();
        }
        /**
         * @param {?} resumableChunk
         * @return {?}
         */
        function preprocessChunkInlineFn(resumableChunk) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            if (typeof that.preprocessChunkFn === 'function') {
                that.preprocessChunkFn(resumableChunk);
            }
            else {
                resumableChunk.preprocessFinished();
            }
        }
        /**
         * @param {?} resumableFile
         * @return {?}
         */
        function preprocessFileInlineFn(resumableFile) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            if (typeof that.preprocessFileFn === 'function') {
                that.changeItemStatus(resumableFile.internalItem, TransferStatus.Preprocessing);
                that.preprocessFileFn(resumableFile);
            }
            else {
                if (ConfigService.settings.core.preprocessHashEnabled && ConfigService.settings.core.preprocessHashChecked) {
                    that.changeItemStatus(resumableFile.internalItem, TransferStatus.Preprocessing);
                    /** @type {?} */
                    var continueCallback = (/**
                     * @return {?}
                     */
                    function () {
                        resumableFile.preprocessFinished();
                    });
                    /** @type {?} */
                    var cancelCallback = (/**
                     * @return {?}
                     */
                    function () {
                        resumableFile.cancel();
                        that.changeItemStatus(resumableFile.internalItem, TransferStatus.Finished, resumableFile.internalItem.message);
                        that.r.uploadNextChunk();
                    });
                    that.preprocessHash(resumableFile.internalItem, resumableFile.file, continueCallback, cancelCallback);
                }
                else {
                    resumableFile.preprocessFinished();
                }
            }
        }
        ConfigService.settings.resumablejs.generateUniqueIdentifier = generateId.bind(this);
        if (typeof ConfigService.settings.resumablejs.preprocess === 'function') {
            // clones the function with '{}' acting as it's new 'this' parameter
            this.preprocessChunkFn = ConfigService.settings.resumablejs.preprocess.bind({});
        }
        ConfigService.settings.resumablejs.preprocess = preprocessChunkInlineFn.bind(this);
        if (typeof ConfigService.settings.resumablejs.preprocessFile === 'function') {
            // clones the function with '{}' acting as it's new 'this' parameter
            this.preprocessFileFn = ConfigService.settings.resumablejs.preprocessFile.bind({});
        }
        ConfigService.settings.resumablejs.preprocessFile = preprocessFileInlineFn.bind(this);
        // @ts-ignore: ignore type checking
        this.r = new Resumable(ConfigService.settings.resumablejs);
        this.r.on('fileAdded', (/**
         * @param {?} file
         * @param {?} event
         * @return {?}
         */
        function (file, event) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('fileAdded', file);
            /** @type {?} */
            var newItem = new DatatransferItem({
                id: file.uniqueIdentifier,
                name: file.fileName,
                path: file.relativePath.substr(0, file.relativePath.length - file.fileName.length),
                sizeContainer: new SizeContainer({ decimalByteUnit: DecimalByteUnit.Byte, decimalByteUnitSize: file.size }),
                progressContainer: new ProgressContainer(file.size),
                transferType: TransferType.Upload,
                status: TransferStatus.Ready,
                externalItem: file
            });
            file.internalItem = newItem;
            that.addItem(newItem);
        }).bind(this));
        this.r.on('fileProgress', (/**
         * @param {?} file
         * @param {?} message
         * @return {?}
         */
        function (file, message) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('fileProgress', file.progress());
            that.changeItemStatus(file.internalItem, TransferStatus.Uploading);
            that.updateItemProgress(file.internalItem, file.progress());
            that.updateOverallProgress(that.transferType, that.r.progress());
        }).bind(this));
        this.r.on('fileSuccess', (/**
         * @param {?} file
         * @param {?} message
         * @return {?}
         */
        function (file, message) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('fileSuccess', file);
            that.changeItemStatus(file.internalItem, TransferStatus.Finished, message);
        }).bind(this));
        this.r.on('fileError', (/**
         * @param {?} file
         * @param {?} message
         * @return {?}
         */
        function (file, message) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('fileError', file, message);
            that.changeItemStatus(file.internalItem, TransferStatus.Failed, message);
        }).bind(this));
        this.r.on('uploadStart', (/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('uploadStart', that.r);
            that._isWorking = true;
            that.updateZone();
            that.updateOverallProgress(that.transferType, that.r.progress());
            that.updateOverallSize(that.r.getSize());
        }).bind(this));
        this.r.on('chunkingComplete', (/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('chunkingComplete');
        }).bind(this));
        this.r.on('pause', (/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('pause');
            that._isWorking = false;
            that.updateZone();
        }).bind(this));
        this.r.on('cancel', (/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('cancel');
            that._isWorking = false;
            that.updateZone();
        }).bind(this));
        this.r.on('complete', (/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            // that.logger.log('complete', that.r);
            that._isWorking = false;
            that.updateZone();
        }).bind(this));
    };
    /**
     * @param {?} element
     * @param {?} isDirectory
     * @return {?}
     */
    ResumableJsUploader.prototype.assignBrowse = /**
     * @param {?} element
     * @param {?} isDirectory
     * @return {?}
     */
    function (element, isDirectory) {
        this.r.assignBrowse(element, isDirectory);
    };
    /**
     * @param {?} element
     * @return {?}
     */
    ResumableJsUploader.prototype.assignDrop = /**
     * @param {?} element
     * @return {?}
     */
    function (element) {
        this.r.assignDrop(element);
    };
    /**
     * @param {?} oldPath
     * @param {?} newPath
     * @return {?}
     */
    ResumableJsUploader.prototype.editPath = /**
     * @param {?} oldPath
     * @param {?} newPath
     * @return {?}
     */
    function (oldPath, newPath) {
        _super.prototype.editPath.call(this, oldPath, newPath);
        this.r.files.forEach((/**
         * @param {?} file
         * @param {?} index
         * @return {?}
         */
        function (file, index) {
            /** @type {?} */
            var internalItem = (/** @type {?} */ (file.internalItem));
            if (internalItem.status === TransferStatus.Ready && internalItem.path === oldPath) {
                file.relativePath = newPath + file.fileName;
                internalItem.path = newPath;
            }
        }));
    };
    /**
     * @param {?} item
     * @param {?} name
     * @return {?}
     */
    ResumableJsUploader.prototype.editFilename = /**
     * @param {?} item
     * @param {?} name
     * @return {?}
     */
    function (item, name) {
        _super.prototype.editFilename.call(this, item, name);
        item.externalItem.fileName = name;
        item.externalItem.relativePath = item.path + name;
        item.name = name;
    };
    /**
     * @return {?}
     */
    ResumableJsUploader.prototype.startAll = /**
     * @return {?}
     */
    function () {
        this.r.upload();
    };
    /**
     * @return {?}
     */
    ResumableJsUploader.prototype.pauseAll = /**
     * @return {?}
     */
    function () {
        // reset preprocessState
        this.r.files.forEach((/**
         * @param {?} file
         * @param {?} index
         * @return {?}
         */
        function (file, index) {
            if (file.preprocessState === 1) {
                file.preprocessState = 0;
            }
        }));
        this.r.pause();
    };
    /**
     * @return {?}
     */
    ResumableJsUploader.prototype.removeAll = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var tempFiles = this.r.files.slice();
        tempFiles.forEach((/**
         * @param {?} file
         * @param {?} index
         * @return {?}
         */
        function (file, index) {
            /** @type {?} */
            var that = (/** @type {?} */ (_this));
            that.r.removeFile(file);
        }));
        this._isWorking = false;
    };
    /**
     * @param {?} item
     * @return {?}
     */
    ResumableJsUploader.prototype.removeItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        this.r.removeFile(item.externalItem);
        if (this.r.files.length <= 0) {
            this._isWorking = false;
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    ResumableJsUploader.prototype.retryItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        item.externalItem.retry();
    };
    ResumableJsUploader.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ResumableJsUploader.ctorParameters = function () { return [
        { type: LoggerService },
        { type: GuidUtil },
        { type: CryptoService }
    ]; };
    return ResumableJsUploader;
}(BaseUploader));
if (false) {
    /**
     * @type {?}
     * @private
     */
    ResumableJsUploader.prototype.r;
    /**
     * @type {?}
     * @private
     */
    ResumableJsUploader.prototype.preprocessFileFn;
    /**
     * @type {?}
     * @private
     */
    ResumableJsUploader.prototype.preprocessChunkFn;
    /**
     * @type {?}
     * @protected
     */
    ResumableJsUploader.prototype.logger;
    /**
     * @type {?}
     * @protected
     */
    ResumableJsUploader.prototype.guidUtil;
    /**
     * @type {?}
     * @protected
     */
    ResumableJsUploader.prototype.cryptoService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/io/downloaders/base.downloader.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IDownloader() { }
if (false) {
    /**
     * @param {?} filename
     * @param {?} url
     * @param {?} sizeInBytes
     * @return {?}
     */
    IDownloader.prototype.download = function (filename, url, sizeInBytes) { };
}
/**
 * @abstract
 */
var  /**
 * @abstract
 */
BaseDownloader = /** @class */ (function (_super) {
    __extends(BaseDownloader, _super);
    function BaseDownloader(logger, guidUtil, cryptoService) {
        var _this = _super.call(this, logger, guidUtil, cryptoService) || this;
        _this.logger = logger;
        _this.guidUtil = guidUtil;
        _this.cryptoService = cryptoService;
        _this.transferType = TransferType.Download;
        return _this;
    }
    return BaseDownloader;
}(BaseDatatransfer));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    BaseDownloader.prototype.transferType;
    /**
     * @type {?}
     * @protected
     */
    BaseDownloader.prototype.logger;
    /**
     * @type {?}
     * @protected
     */
    BaseDownloader.prototype.guidUtil;
    /**
     * @type {?}
     * @protected
     */
    BaseDownloader.prototype.cryptoService;
    /**
     * @abstract
     * @param {?} filename
     * @param {?} url
     * @param {?} sizeInBytes
     * @return {?}
     */
    BaseDownloader.prototype.download = function (filename, url, sizeInBytes) { };
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/common.util.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CommonUtil = /** @class */ (function () {
    function CommonUtil() {
    }
    /**
     * @param {?} o
     * @param {?} callback
     * @return {?}
     */
    CommonUtil.prototype.each = /**
     * @param {?} o
     * @param {?} callback
     * @return {?}
     */
    function (o, callback) {
        if (typeof (o.length) !== 'undefined') {
            for (var i = 0; i < o.length; i++) {
                // Array or FileList
                if (callback(o[i]) === false) {
                    return;
                }
            }
        }
        else {
            for (var i in o) {
                // Object
                if (callback(i, o[i]) === false) {
                    return;
                }
            }
        }
    };
    CommonUtil.decorators = [
        { type: Injectable }
    ];
    return CommonUtil;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/io/downloaders/blob.downloader.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BlobDownloader = /** @class */ (function (_super) {
    __extends(BlobDownloader, _super);
    function BlobDownloader(logger, guidUtil, cryptoService, commonUtil) {
        var _this = _super.call(this, logger, guidUtil, cryptoService) || this;
        _this.logger = logger;
        _this.guidUtil = guidUtil;
        _this.cryptoService = cryptoService;
        _this.commonUtil = commonUtil;
        _this.throttleProgressCallbacks = 0.1;
        _this.files = [];
        _this.queue = [];
        _this.downloading = [];
        return _this;
    }
    /**
     * @return {?}
     */
    BlobDownloader.prototype.startAll = /**
     * @return {?}
     */
    function () {
        if (!this.isWorking()) {
            for (var index = 0; index < ConfigService.settings.core.simultaneousDownloads; index++) {
                this.downloadNext();
            }
        }
    };
    /**
     * @return {?}
     */
    BlobDownloader.prototype.pauseAll = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    BlobDownloader.prototype.removeAll = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.files.forEach((/**
         * @param {?} item
         * @param {?} index
         * @return {?}
         */
        function (item, index) {
            /** @type {?} */
            var that = (/** @type {?} */ (_this));
            that.abortDownload(item);
        }));
        this.files.length = 0;
        this.queue.length = 0;
        this.downloading.length = 0;
        this._isWorking = false;
        this.updateOverallSize(this.getSize());
        this.updateOverallProgress(this.transferType, this.getProgress());
    };
    /**
     * @param {?} item
     * @return {?}
     */
    BlobDownloader.prototype.removeItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        this.abortDownload(item);
        this.removeItemFromArray(item, this.files);
        this.removeItemFromArray(item, this.queue);
        this.removeItemFromArray(item, this.downloading);
        this.downloadNext();
    };
    /**
     * @private
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    BlobDownloader.prototype.removeItemFromArray = /**
     * @private
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    function (item, array) {
        for (var i = array.length - 1; i >= 0; i--) {
            if (array[i] === item) {
                array.splice(i, 1);
                break;
            }
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    BlobDownloader.prototype.retryItem = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        this.abortDownload(item);
        this.removeItemFromArray(item, this.queue);
        this.removeItemFromArray(item, this.downloading);
        this._isWorking = this.downloading.length > 0;
        item.externalItem.progress = 0;
        this.updateItemProgress(item, item.externalItem.progress);
        this.changeItemStatus(item, TransferStatus.Queued);
        this.queue.push(item);
        this.initDownload(item);
        this.downloadNext();
    };
    /**
     * @param {?} filename
     * @param {?} url
     * @param {?} sizeInBytes
     * @return {?}
     */
    BlobDownloader.prototype.download = /**
     * @param {?} filename
     * @param {?} url
     * @param {?} sizeInBytes
     * @return {?}
     */
    function (filename, url, sizeInBytes) {
        /** @type {?} */
        var newItem = new DatatransferItem({
            id: this.generateUniqueIdentifier(),
            name: filename,
            sizeContainer: new SizeContainer({ decimalByteUnit: DecimalByteUnit.Byte, decimalByteUnitSize: sizeInBytes }),
            progressContainer: new ProgressContainer(sizeInBytes),
            transferType: TransferType.Download,
            status: TransferStatus.Queued,
            externalItem: {
                url: url,
                progress: 0,
                size: sizeInBytes,
                lastProgressCallback: new Date()
            }
        });
        this.addItem(newItem);
        this.files.push(newItem);
        this.queue.push(newItem);
        this.initDownload(newItem);
        this.downloadNext();
    };
    /**
     * @private
     * @param {?} item
     * @return {?}
     */
    BlobDownloader.prototype.initDownload = /**
     * @private
     * @param {?} item
     * @return {?}
     */
    function (item) {
        /** @type {?} */
        var xhr = new XMLHttpRequest();
        item.externalItem.xhr = xhr;
        xhr.open(ConfigService.settings.core.downloadMethod, item.externalItem.url);
        xhr.timeout = ConfigService.settings.core.downloadXhrTimeout;
        xhr.withCredentials = ConfigService.settings.core.downloadWithCredentials;
        // Add data from header options
        /** @type {?} */
        var customHeaders = ConfigService.settings.core.downloadHeaders;
        if (typeof customHeaders === 'function') {
            customHeaders = customHeaders(item);
        }
        this.commonUtil.each(customHeaders, (/**
         * @param {?} k
         * @param {?} v
         * @return {?}
         */
        function (k, v) {
            xhr.setRequestHeader(k, v);
        }));
        xhr.responseType = 'blob';
        xhr.onloadstart = (/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            that.changeItemStatus(item, TransferStatus.Downloading);
        }).bind(this);
        xhr.onprogress = (/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            if (new Date().getTime() - item.externalItem.lastProgressCallback.getTime() > that.throttleProgressCallbacks * 1000) {
                item.externalItem.progress = e.loaded / e.total;
                that.updateItemProgress(item, item.externalItem.progress);
                that.updateOverallProgress(that.transferType, that.getProgress());
                item.externalItem.lastProgressCallback = new Date();
            }
        }).bind(this);
        xhr.onloadend = (/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /*
                        Value	State	Description
                        0	UNSENT	Client has been created. open() not called yet.
                        1	OPENED	open() has been called.
                        2	HEADERS_RECEIVED	send() has been called, and headers and status are available.
                        3	LOADING	Downloading; responseText holds partial data.
                        4	DONE	The operation is complete.
                        */
            /** @type {?} */
            var that = (/** @type {?} */ (this));
            if (xhr.readyState === 4) {
                item.externalItem.progress = 1;
                that.updateItemProgress(item, item.externalItem.progress);
                if (xhr.status === 200) {
                    that.changeItemStatus(item, TransferStatus.Finished);
                    saveAs(xhr.response, item.name);
                }
                else if (xhr.status !== 0) { // don't change status for aborted items
                    that.changeItemStatus(item, TransferStatus.Failed);
                }
                that.removeItemFromArray(item, that.downloading);
                that.downloadNext();
            }
        }).bind(this);
    };
    /**
     * @private
     * @return {?}
     */
    BlobDownloader.prototype.downloadNext = /**
     * @private
     * @return {?}
     */
    function () {
        this.updateOverallSize(this.getSize());
        this.updateOverallProgress(this.transferType, this.getProgress());
        if (this.downloading.length < ConfigService.settings.core.simultaneousDownloads) {
            /** @type {?} */
            var item = this.queue.shift();
            if (!!item && !!item.externalItem && !!item.externalItem.xhr) {
                this.changeItemStatus(item, TransferStatus.Downloading);
                this.downloading.push(item);
                this._isWorking = this.downloading.length > 0;
                item.externalItem.xhr.send();
            }
        }
    };
    /**
     * @private
     * @param {?} item
     * @return {?}
     */
    BlobDownloader.prototype.abortDownload = /**
     * @private
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (!!item && !!item.externalItem && !!item.externalItem.xhr) {
            item.externalItem.xhr.abort();
            item.externalItem.xhr = null;
        }
    };
    /**
     * @private
     * @return {?}
     */
    BlobDownloader.prototype.getSize = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var totalSize = 0;
        this.files.forEach((/**
         * @param {?} file
         * @param {?} index
         * @return {?}
         */
        function (file, index) {
            totalSize += file.externalItem.size;
        }));
        return totalSize;
    };
    /**
     * @private
     * @return {?}
     */
    BlobDownloader.prototype.getProgress = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var totalDone = 0;
        /** @type {?} */
        var totalSize = 0;
        this.files.forEach((/**
         * @param {?} file
         * @param {?} index
         * @return {?}
         */
        function (file, index) {
            /** @type {?} */
            var currentFileProgress = file.externalItem.progress;
            if (file.status === TransferStatus.Failed) {
                currentFileProgress = 1;
            }
            totalDone += currentFileProgress * file.externalItem.size;
            totalSize += file.externalItem.size;
        }));
        return totalSize > 0 ? totalDone / totalSize : 0;
    };
    BlobDownloader.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    BlobDownloader.ctorParameters = function () { return [
        { type: LoggerService },
        { type: GuidUtil },
        { type: CryptoService },
        { type: CommonUtil }
    ]; };
    return BlobDownloader;
}(BaseDownloader));
if (false) {
    /**
     * @type {?}
     * @private
     */
    BlobDownloader.prototype.throttleProgressCallbacks;
    /**
     * @type {?}
     * @private
     */
    BlobDownloader.prototype.files;
    /**
     * @type {?}
     * @private
     */
    BlobDownloader.prototype.queue;
    /**
     * @type {?}
     * @private
     */
    BlobDownloader.prototype.downloading;
    /**
     * @type {?}
     * @protected
     */
    BlobDownloader.prototype.logger;
    /**
     * @type {?}
     * @protected
     */
    BlobDownloader.prototype.guidUtil;
    /**
     * @type {?}
     * @protected
     */
    BlobDownloader.prototype.cryptoService;
    /**
     * @type {?}
     * @private
     */
    BlobDownloader.prototype.commonUtil;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/factories/datatransfer-facade.factory.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DatatransferFacadeFactory = /** @class */ (function () {
    function DatatransferFacadeFactory(logger, zone, store, dateUtil, paginationService, exportService, dialog, resumableUploader, blobDownloader) {
        this.logger = logger;
        this.zone = zone;
        this.store = store;
        this.dateUtil = dateUtil;
        this.paginationService = paginationService;
        this.exportService = exportService;
        this.dialog = dialog;
        this.resumableUploader = resumableUploader;
        this.blobDownloader = blobDownloader;
    }
    // TODO: pass arguments to define which uploader/downloader implementation should be used
    // TODO: pass arguments to define which uploader/downloader implementation should be used
    /**
     * @return {?}
     */
    DatatransferFacadeFactory.prototype.createDatatransferFacade = 
    // TODO: pass arguments to define which uploader/downloader implementation should be used
    /**
     * @return {?}
     */
    function () {
        if (!this.facade1) {
            this.facade1 = new DatatransferFacade(this.logger, this.zone, this.store, this.dateUtil, this.paginationService, this.exportService, this.resumableUploader, this.blobDownloader, this.dialog);
        }
        return this.facade1;
    };
    DatatransferFacadeFactory.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DatatransferFacadeFactory.ctorParameters = function () { return [
        { type: LoggerService },
        { type: NgZone },
        { type: DatatransferStore },
        { type: DateUtil },
        { type: PaginationService },
        { type: ExportService },
        { type: MatDialog },
        { type: ResumableJsUploader },
        { type: BlobDownloader }
    ]; };
    return DatatransferFacadeFactory;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.facade1;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.logger;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.zone;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.store;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.dateUtil;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.paginationService;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.exportService;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.dialog;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.resumableUploader;
    /**
     * @type {?}
     * @private
     */
    DatatransferFacadeFactory.prototype.blobDownloader;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/angular-material-datatransfer.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularMaterialDatatransferComponent = /** @class */ (function () {
    function AngularMaterialDatatransferComponent(componentFactoryResolver, datatransferFacadeFactory, configService, paginationService) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.datatransferFacadeFactory = datatransferFacadeFactory;
        this.configService = configService;
        this.paginationService = paginationService;
    }
    /**
     * @return {?}
     */
    AngularMaterialDatatransferComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        document.dispatchEvent(new Event(CustomEventTypeExtensions.toString(CustomEventType.INIT)));
    };
    /**
     * @param {?} config
     * @return {?}
     */
    AngularMaterialDatatransferComponent.prototype.create = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        this.setConfig(config);
    };
    /**
     * @param {?} config
     * @return {?}
     */
    AngularMaterialDatatransferComponent.prototype.setConfig = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        this.configService.load(config);
        this.paginationService.setRppOptions(ConfigService.settings.core.paginationRppOptions);
        this.datatransferFacade = this.datatransferFacadeFactory.createDatatransferFacade();
        /** @type {?} */
        var viewContainerRef = this.amdHost.viewContainerRef;
        viewContainerRef.clear();
        /** @type {?} */
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(MainComponent);
        /** @type {?} */
        var componentRef = viewContainerRef.createComponent(componentFactory);
        /** @type {?} */
        var componentRefInstance = (/** @type {?} */ (componentRef.instance));
        componentRefInstance.datatransferFacade = this.datatransferFacade;
    };
    /**
     * @param {?} filename
     * @param {?} url
     * @param {?} size
     * @return {?}
     */
    AngularMaterialDatatransferComponent.prototype.download = /**
     * @param {?} filename
     * @param {?} url
     * @param {?} size
     * @return {?}
     */
    function (filename, url, size) {
        this.datatransferFacade.download(filename, url, size);
    };
    AngularMaterialDatatransferComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'angular-material-datatransfer-lib',
                    template: "<div class=\"angular-material-datatransfer\">\r\n    <ng-template amd-host></ng-template>\r\n</div>"
                }] }
    ];
    /** @nocollapse */
    AngularMaterialDatatransferComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: DatatransferFacadeFactory },
        { type: ConfigService },
        { type: PaginationService }
    ]; };
    AngularMaterialDatatransferComponent.propDecorators = {
        amdHost: [{ type: ViewChild, args: [HostDirective, { static: true },] }]
    };
    return AngularMaterialDatatransferComponent;
}());
if (false) {
    /** @type {?} */
    AngularMaterialDatatransferComponent.prototype.amdHost;
    /**
     * @type {?}
     * @private
     */
    AngularMaterialDatatransferComponent.prototype.datatransferFacade;
    /**
     * @type {?}
     * @private
     */
    AngularMaterialDatatransferComponent.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    AngularMaterialDatatransferComponent.prototype.datatransferFacadeFactory;
    /**
     * @type {?}
     * @private
     */
    AngularMaterialDatatransferComponent.prototype.configService;
    /**
     * @type {?}
     * @private
     */
    AngularMaterialDatatransferComponent.prototype.paginationService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/dropzone.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DropzoneComponent = /** @class */ (function () {
    function DropzoneComponent() {
    }
    DropzoneComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'amd-dropzone',
                    template: "<div class=\"amd-dropzone\" id=\"amd-dropzone-component\">\r\n    <div class=\"amd-dropzone-content\">\r\n        <mat-icon style=\"font-size: 64px; color: rgba(255, 255, 255, 1);\">insert_drive_file</mat-icon>\r\n        <mat-icon style=\"margin-left: 10px;\">add_circle_outline</mat-icon>\r\n        <p>Drop your files/folders here or click to upload.</p>\r\n    </div>\r\n</div>"
                }] }
    ];
    /** @nocollapse */
    DropzoneComponent.ctorParameters = function () { return []; };
    return DropzoneComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/pagination.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PaginationComponent = /** @class */ (function () {
    function PaginationComponent(logger) {
        this.logger = logger;
    }
    /**
     * @return {?}
     */
    PaginationComponent.prototype.max = /**
     * @return {?}
     */
    function () {
        return this.paginationService.max();
    };
    ;
    /**
     * @return {?}
     */
    PaginationComponent.prototype.min = /**
     * @return {?}
     */
    function () {
        return this.paginationService.min();
    };
    ;
    /**
     * @return {?}
     */
    PaginationComponent.prototype.first = /**
     * @return {?}
     */
    function () {
        this.paginationService.first();
    };
    /**
     * @return {?}
     */
    PaginationComponent.prototype.last = /**
     * @return {?}
     */
    function () {
        this.paginationService.last();
    };
    /**
     * @return {?}
     */
    PaginationComponent.prototype.hasNext = /**
     * @return {?}
     */
    function () {
        return this.paginationService.hasNext();
    };
    /**
     * @return {?}
     */
    PaginationComponent.prototype.hasPrevious = /**
     * @return {?}
     */
    function () {
        return this.paginationService.hasPrevious();
    };
    ;
    /**
     * @return {?}
     */
    PaginationComponent.prototype.moveNext = /**
     * @return {?}
     */
    function () {
        this.paginationService.moveNext();
    };
    /**
     * @return {?}
     */
    PaginationComponent.prototype.movePrevious = /**
     * @return {?}
     */
    function () {
        this.paginationService.movePrevious();
    };
    /**
     * @return {?}
     */
    PaginationComponent.prototype.onPageChange = /**
     * @return {?}
     */
    function () {
        this.paginationService.onPageChange();
    };
    /**
     * @return {?}
     */
    PaginationComponent.prototype.onRppChange = /**
     * @return {?}
     */
    function () {
        this.paginationService.onRppChange();
    };
    /**
     * @return {?}
     */
    PaginationComponent.prototype.onPaginationChange = /**
     * @return {?}
     */
    function () {
        this.paginationService.onPaginationChange();
    };
    /**
     * @return {?}
     */
    PaginationComponent.prototype.pageCount = /**
     * @return {?}
     */
    function () {
        return this.paginationService.pageCount();
    };
    PaginationComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'amd-pagination',
                    template: "<mat-form-field>\r\n    <mat-select placeholder=\"Page\" [(ngModel)]=\"paginationService.pagination.page\" (change)=\"onPageChange()\" aria-label=\"Page\">\r\n        <mat-option *ngFor=\"let p of paginationService.pagination.pages\" [value]=\"p\">\r\n            {{ p }}\r\n        </mat-option>\r\n    </mat-select>\r\n</mat-form-field>\r\n<mat-form-field>\r\n    <mat-select placeholder=\"Rows per page\" [(ngModel)]=\"paginationService.pagination.rpp\" (change)=\"onRppChange()\" aria-label=\"Rows per page\">\r\n        <mat-option *ngFor=\"let o of paginationService.pagination.rppOptions\" [value]=\"o\">\r\n            {{ o }}\r\n        </mat-option>\r\n    </mat-select>\r\n</mat-form-field>\r\n<span>{{min()}} - {{max()}} of {{paginationService.pagination.total}}</span>\r\n<button mat-icon-button mat-button (click)=\"movePrevious()\" [disabled]=\"!hasPrevious()\">\r\n    <mat-icon>navigate_before</mat-icon>\r\n</button>\r\n<button mat-icon-button mat-button (click)=\"moveNext()\" [disabled]=\"!hasNext()\">\r\n    <mat-icon>navigate_next</mat-icon>\r\n</button>"
                }] }
    ];
    /** @nocollapse */
    PaginationComponent.ctorParameters = function () { return [
        { type: LoggerService }
    ]; };
    PaginationComponent.propDecorators = {
        paginationService: [{ type: Input }]
    };
    return PaginationComponent;
}());
if (false) {
    /** @type {?} */
    PaginationComponent.prototype.paginationService;
    /**
     * @type {?}
     * @private
     */
    PaginationComponent.prototype.logger;
    /* Skipping unhandled member: ;*/
    /* Skipping unhandled member: ;*/
    /* Skipping unhandled member: ;*/
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/progress.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ProgressComponent = /** @class */ (function () {
    function ProgressComponent() {
    }
    ProgressComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'amd-progress',
                    template: "<div style=\"font-size: 11px; margin-top: 10px;\">\r\n    <div fxFlex=\"25%\" fxFlex.lt-md=\"50%\">\r\n        {{progressContainer.displayBitrate}}\r\n    </div>\r\n    <div fxFlex=\"25%\" fxHide.lt-md style=\"text-align: center\">\r\n        {{progressContainer.displayTimeLeft}}\r\n    </div>\r\n    <div fxFlex=\"25%\" fxHide.lt-md style=\"text-align: center\">\r\n        {{progressContainer.percent}}%\r\n    </div>\r\n    <div fxFlex=\"25%\" fxFlex.lt-md=\"50%\" style=\"text-align: right\">\r\n        {{progressContainer.loadedSizeContainer.displaySize}} / {{progressContainer.totalSizeContainer.displaySize}} {{progressContainer.totalSizeContainer.displayUnit}}\r\n    </div>\r\n</div>\r\n<mat-progress-bar *ngIf=\"progressContainer.total > 0\" [value]=\"progressContainer.percent\">\r\n</mat-progress-bar>"
                }] }
    ];
    /** @nocollapse */
    ProgressComponent.ctorParameters = function () { return []; };
    ProgressComponent.propDecorators = {
        progressContainer: [{ type: Input }]
    };
    return ProgressComponent;
}());
if (false) {
    /** @type {?} */
    ProgressComponent.prototype.progressContainer;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/demo.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DemoService = /** @class */ (function () {
    function DemoService() {
        this.title = 'angular-material-datatransfer';
        this.testItems = [
            new DatatransferItem({
                id: '1',
                name: 'DICOM_patientXY_1.dcm',
                path: '/mnt/sdcard/folder1/a/b/',
                sizeContainer: new SizeContainer({ decimalByteUnit: DecimalByteUnit.MB, decimalByteUnitSize: 15 }),
                progressContainer: new ProgressContainer(15 * 1000 * 1000),
                transferType: TransferType.Upload,
                status: TransferStatus.Uploading
            }),
            new DatatransferItem({
                id: '2',
                name: 'DICOM_patientXY_2.dcm',
                path: '/mnt/sdcard/folder1/a/b/',
                sizeContainer: new SizeContainer({ decimalByteUnit: DecimalByteUnit.MB, decimalByteUnitSize: 17 }),
                transferType: TransferType.Upload,
                status: TransferStatus.Failed
            }),
            new DatatransferItem({
                id: '3',
                name: 'DICOM_patientXY_3.dcm',
                path: '/mnt/sdcard/folder1/a/b/',
                preprocessContainer: new PreprocessContainer({ percent: 30 }),
                sizeContainer: new SizeContainer({ decimalByteUnit: DecimalByteUnit.MB, decimalByteUnitSize: 13 }),
                transferType: TransferType.Upload,
                status: TransferStatus.Preprocessing
            }),
            new DatatransferItem({
                id: '4',
                name: 'DICOM_patientXY_4.dcm',
                path: '/mnt/sdcard/folder1/a/b/',
                sizeContainer: new SizeContainer({ decimalByteUnit: DecimalByteUnit.MB, decimalByteUnitSize: 11 }),
                transferType: TransferType.Upload,
                status: TransferStatus.Queued,
            }),
            new DatatransferItem({
                id: '5',
                name: 'SMIR.Thorax.089Y.M.CT.7.000.dcm.zip',
                path: '/',
                sizeContainer: new SizeContainer({ decimalByteUnit: DecimalByteUnit.GB, decimalByteUnitSize: 2 }),
                transferType: TransferType.Download,
                status: TransferStatus.Queued
            }),
            new DatatransferItem({
                id: '6',
                name: 'NIFTI_patientXY.nii',
                path: '/mnt/sdcard/folder2/d/',
                sizeContainer: new SizeContainer({ decimalByteUnit: DecimalByteUnit.GB, decimalByteUnitSize: 12 }),
                transferType: TransferType.Upload,
                status: TransferStatus.Queued,
            })
        ];
    }
    DemoService.decorators = [
        { type: Injectable }
    ];
    return DemoService;
}());
if (false) {
    /** @type {?} */
    DemoService.prototype.title;
    /** @type {?} */
    DemoService.prototype.testItems;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/angular-material-datatransfer.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularMaterialDatatransferModule = /** @class */ (function () {
    function AngularMaterialDatatransferModule(appRef) {
        this.appRef = appRef;
    }
    AngularMaterialDatatransferModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        AngularMaterialDatatransferComponent,
                        MainComponent,
                        BrowseDialogComponent,
                        DropzoneComponent,
                        EditDialogComponent,
                        PaginationComponent,
                        ProgressComponent,
                        HostDirective
                    ],
                    imports: [
                        BrowserModule,
                        BrowserAnimationsModule,
                        FormsModule,
                        ReactiveFormsModule,
                        MatButtonModule,
                        MatCheckboxModule,
                        MatDialogModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                        MatMenuModule,
                        MatOptionModule,
                        MatProgressBarModule,
                        MatProgressSpinnerModule,
                        MatSelectModule,
                        MatTooltipModule,
                        FlexLayoutModule
                    ],
                    exports: [AngularMaterialDatatransferComponent],
                    entryComponents: [
                        MainComponent,
                        BrowseDialogComponent,
                        EditDialogComponent
                    ],
                    providers: [
                        ConfigService,
                        LoggerService,
                        PaginationService,
                        ExportService,
                        DemoService,
                        CryptoService,
                        DatatransferStore,
                        DatatransferFacadeFactory,
                        CommonUtil,
                        DateUtil,
                        DecimalByteUnitUtil,
                        GuidUtil,
                        CsvExporter,
                        JsonExporter,
                        ResumableJsUploader,
                        BlobDownloader
                    ]
                },] }
    ];
    /** @nocollapse */
    AngularMaterialDatatransferModule.ctorParameters = function () { return [
        { type: ApplicationRef }
    ]; };
    return AngularMaterialDatatransferModule;
}());
if (false) {
    /** @type {?} */
    AngularMaterialDatatransferModule.prototype.appRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: angular-material-datatransfer-lib.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AngularMaterialDatatransferComponent, AngularMaterialDatatransferModule, HostDirective as ɵa, DatatransferFacadeFactory as ɵb, DemoService as ɵba, DecimalByteUnitUtil as ɵbb, LoggerService as ɵc, DatatransferStore as ɵd, DateUtil as ɵe, PaginationService as ɵf, ExportService as ɵg, CsvExporter as ɵh, BaseExporter as ɵi, JsonExporter as ɵj, ResumableJsUploader as ɵk, BaseUploader as ɵl, BaseDatatransfer as ɵm, GuidUtil as ɵn, CryptoService as ɵo, BlobDownloader as ɵp, BaseDownloader as ɵq, CommonUtil as ɵr, ConfigService as ɵs, AppConfig as ɵt, MainComponent as ɵu, BrowseDialogComponent as ɵv, DropzoneComponent as ɵw, EditDialogComponent as ɵx, PaginationComponent as ɵy, ProgressComponent as ɵz };
//# sourceMappingURL=angular-material-datatransfer-lib.js.map
